#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/TextF.h>
#include <Xm/DrawnB.h>
#include <Xm/RowColumn.h>
#include <Xm/PushBG.h>
#include "jbdbg.h"
#include "jex.h"
#include "list.h"

List combo_list=NULL;
extern Pixmap lov;
extern OwnRes ownres;

void ComboBoxSelect(Widget w,Widget text,void *cbs)
{
  ComboBox c;
  int x;
  
SP("ComboBoxSelect");
  if (!FindElement(combo_list,&c,sizeof(Widget),&text))
  {
    EP;
    return;
  }
  for (x=0;x<c.itemcount;x++)
  {
    if (c.items[x].button==w)
    {
      XtVaSetValues(text,XmNvalue,c.items[x].item,NULL);
      if (c.function)
        c.function(w,c.client_data,cbs);
      break;
    }
  }
EP;
}

void UpdateComboBox(Widget w,char *str)
{
  int x,end,exists=0;
  XmString xstr;
  ComboBox c;

SP("UpdateComboBox");
  if (!FindElement(combo_list,&c,sizeof(Widget),&w))
  {
    EP;
    return;
  }
  end=c.itemcount;
  if (str && str[0])
  {
    for (x=0;x<c.itemcount;x++)
    {
      if (db_strcmp(c.items[x].item,str)==0)
      {
        end=x+1;
        exists=1;
        break;
      }
    }
    if (c.itemcount<c.maxitems && !exists)
    {
      if (c.form)
      {
        c.items[c.itemcount].button=XtVaCreateManagedWidget("combobutton",
            xmPushButtonGadgetClass,c.popup,NULL);
        XtAddCallback(c.items[c.itemcount].button,XmNactivateCallback,(XtCallbackProc)ComboBoxSelect,c.text);
      }
      c.items[c.itemcount].item=NULL;
      c.itemcount++;
      end=c.itemcount;
    }
    for (x=end-2;x>=0;x--)
    {
      c.items[x+1].item=(char*)db_realloc(c.items[x+1].item,db_strlen(c.items[x].item)+1);
      db_strcpy(c.items[x+1].item,c.items[x].item);
    }
    c.items[0].item=(char*)db_realloc(c.items[0].item,db_strlen(str)+1);
    db_strcpy(c.items[0].item,str);
  }
  for (x=0;c.form && x<end;x++)
  {
    xstr=XmStringCreateLocalized(c.items[x].item);
    XtVaSetValues(c.items[x].button,XmNlabelString,xstr,NULL);
    XmStringFree(xstr);
  }
  ReplaceCurrentElement(combo_list,&c);
EP;
}

void ShowComboMenu(Widget b,Widget text,XmPushButtonCallbackStruct *cbs)
{
  Position y,y2,h,x,x2,w;
  Widget tmp;
  ComboBox c;
  XButtonPressedEvent xbe;

SP("ShowComboMenu");
  if (!FindElement(combo_list,&c,sizeof(Widget),&text))
  {
    EP;
    return;
  }
  xbe=*(XButtonPressedEvent*)&cbs->event;
  tmp=XtParent(c.text);
  y2=0;
  x2=0;
  while (!XtIsShell(tmp))
  {
    XtVaGetValues(tmp,XmNx,&x,XmNy,&y,NULL);
    x2+=x;
    y2+=y;
    tmp=XtParent(tmp);
  }
  XtVaGetValues(c.text,XmNx,&x,XmNy,&y,XmNwidth,&w,XmNheight,&h,NULL);
  xbe.y_root=y2+y+h;
  xbe.x_root=x2+x;
  XtVaGetValues(c.button,XmNwidth,&x,NULL);
  w+=x;
  if (c.itemcount)
    XtVaSetValues(c.items[0].button,XmNwidth,w,NULL);
  XmMenuPosition(c.popup,&xbe);
  XtManageChild(c.popup);
EP;
}

Widget CreateComboBox(Widget parent,String name,ArgList arglist,Cardinal argcount,int maxitems)
{
  ComboBox c;
  char str[100];
  
  SP("CreateComboBox");
  if (!combo_list)
    combo_list=CreateList(sizeof(ComboBox));
  c.maxitems=maxitems;
  c.itemcount=0;
  c.items=(ComboButton*)db_malloc(sizeof(ComboButton)*maxitems);
  c.function=NULL;
  if (parent)
  {
    db_sprintf(str,"%s_form",name);
    c.form=XmCreateForm(parent,str,arglist,argcount);
    XtManageChild(c.form);
    db_sprintf(str,"%s_button",name);
    c.button=XtVaCreateManagedWidget(str,xmDrawnButtonWidgetClass,c.form,
          XmNrightAttachment,XmATTACH_FORM,
          XmNtopAttachment,XmATTACH_FORM,
          XmNbottomAttachment,XmATTACH_FORM,
          XmNlabelType,XmPIXMAP,
          XmNlabelPixmap,lov,
          XmNhighlightThickness,0,
          XmNtopOffset,2,
          XmNbottomOffset,2,
          NULL);
    c.text=XtVaCreateManagedWidget(name,xmTextFieldWidgetClass,c.form,
          XmNleftAttachment,XmATTACH_FORM,
          XmNtopAttachment,XmATTACH_FORM,
          XmNbottomAttachment,XmATTACH_FORM,
          XmNrightAttachment,XmATTACH_WIDGET,
          XmNrightWidget,c.button,
          NULL);
    db_sprintf(str,"%s_popup",name);
    c.popup=XmVaCreateSimplePopupMenu(c.form,str,NULL,
          NULL);
    XtAddCallback(c.button,XmNarmCallback,(XtCallbackProc)ShowComboMenu,c.text);  
  }
  else
  {
    c.text=(Widget)db_strdup(name);
    c.form=NULL;
    c.button=NULL;
    c.popup=NULL;
  }
  AddElement(combo_list,&c);
EP;
  return c.text;
}  	

void DestroyAllComboBoxes(void)
{
  ComboBox c;
  int x;

  if (combo_list)
  {
    if (GetFirstElement(combo_list,&c))
    {
      do
      {
        for (x=0;x<c.itemcount;x++)
          db_free(c.items[x].item);
        db_free(c.items);
        if (!c.form)
          db_free(c.text);
      } while (GetNextElement(combo_list,&c));
    }
    DisposeList(combo_list);
  }
}

int GetComboBox(Widget w,ComboBox *c)
{
  SP("GetComboBox");
  if (!FindElement(combo_list,c,sizeof(Widget),&w))
  {
    EP;
    return 0;
  }
  EP;
  return 1;
}

void InitializeComboBox(Widget w,Widget ref)
{
  ComboBox c;
  int x;
  char *home,file[255],ini[255],*param,str[255],label[255];
  FILE *f;
  
  SP("InitializeComboBox");
  if (editors)
  {
    if (!GetComboBox(ref,&c))
    {
      EP;
      return;
    }
    for (x=0;x<c.itemcount;x++)
      UpdateComboBox(w,c.items[x].item);
  }
  else
  {
    if (!GetComboBox(w,&c))
    {
      EP;
      return;
    }
    if ((int)ownres.histhome)
    {
      home=getenv("HOME");
      if (home)
        db_sprintf(file,"%s/.jexhistory",home);
      else
        db_strcpy(file,".jexhistory");
    }
    else
      db_strcpy(file,".jexhistory");
    if ((f=fopen(file,"r"))==NULL)
    {
      EP;
      return;
    }
    sprintf(label,"%s:",(c.form!=NULL)?XtName(w):(char*)w);
    while (fgets(str,255,f))
    {
      str[db_strlen(str)-1]='\0';
      sscanf(str,"%s",ini);
      param=&str[db_strlen(ini)+1];
      if (!strcmp(ini,label))
        UpdateComboBox(w,param);
    }
    fclose(f);
  }
  EP;
}

void CopyComboBoxToFile(Widget w,FILE *f)
{
  ComboBox c;
  int x;
  
  SP("CopyComboBoxToFile");
  if (GetComboBox(w,&c))
  {
    for (x=0;x<c.itemcount;x++)
      fprintf(f,"%s: %s\n",(c.form!=NULL)?XtName(w):(char*)w,c.items[x].item);
  }
  EP;
}

void ComboBoxAddCallback(Widget w,XtCallbackProc f,void *d)
{
  ComboBox c;
  
  if (!GetComboBox(w,&c))
    return;
  c.function=f;
  c.client_data=d;
  ReplaceCurrentElement(combo_list,&c);
}
