#define _DEBUG_ 0

#include <stdio.h>
#include <ctype.h>
#include "jbdbg.h"

char *functions[]={
"malloc(",
"free(",
"realloc(",
"calloc(",
"strcpy(",
"strncpy(",
"strcmp(",
"strdup(",
"memchr(",
"memcmp(",
"memcpy(",
"memmove(",
"memset(",
"strcat(",
"strchr(",
"strcspn(",
"strlen(",
"strncat(",
"strncmp(",
"strpbrk(",
"strrchr(",
"strspn(",
"strstr(",
"strtok(",
"clearerr(",
"close(",
"creat(",
"fclose(",
"feof(",
"ferror(",
"fflush(",
"fgetc(",
"fgets(",
"fopen(",
"fputc(",
"fputs(",
"fread(",
"freopen(",
"fseek(",
"ftell(",
"fwrite(",
"ungetc(",
"getc(",
"lseek(",
"open(",
"putc(",
"putchar(",
"read(",
"remove(",
"rename(",
"rewind(",
"setbuf(",
"setvbuf(",
"tmpnam(",
"tmpfile(",
"unlink(",
"write(",
"pipe(",
"dup(",
"dup2(",
"fdopen(",
"fstat(",
"lstat(",
"stat(",
"access(",
"opendir(",
"readdir(",
"closedir(",
"chmod(",
"fchmod(",
"chown(",
"fchown(",
"chdir(",
"fchdir(",
"rmdir(",
"truncate(",
"ftruncate(",
"mkdir(",
"link(",
"select(",
"popen(",
"pclose(",
"socket(",
"bind(",
"recv(",
"send(",
"listen(",
"shutdown(",
"accept(",
"connect(",
"sendto(",
"recvfrom(",
"getcwd(",
"scandir(",
NULL};

void ReplaceString(char *str,char *srch,char *repl)
{
  int x;
  
  for (x=0;x<db_strlen(str);x++)
  {
    if (x>db_strlen(str)-db_strlen(srch))
      return;
    if (db_memcmp(&str[x],srch,db_strlen(srch))==0)
    {
      if (x==0 || (x>0 && !isalpha(str[x-1]) && str[x-1]!='_'))
      {
        db_memmove(&str[x],&str[x+db_strlen(srch)],db_strlen(str)-x-db_strlen(srch)+1);
        db_memmove(&str[x+db_strlen(repl)],&str[x],db_strlen(str)-x+1);
        db_memcpy(&str[x],repl,db_strlen(repl));
        x+=db_strlen(repl);
      }
    }
  }
}

void TranslateFile(char *file)
{
  FILE *f,*f2,*f3;
  char *str,backup[255],nw[255],*str2;
  int y,first=1;
  
  if ((f=db_fopen(file,"r"))==NULL)
  {
    printf("Cannot open file %s\n",file);
    return;
  }
  sprintf(backup,"%s.bak",file);
  if ((f2=db_fopen(backup,"w+"))==NULL)
  {
    printf("Cannot open file %s\n",backup);
    db_fclose(f);
    return;
  }
  sprintf(nw,"%s.tmp",file);
  if ((f3=db_fopen(nw,"w+"))==NULL)
  {
    printf("Cannot open file %s\n",nw);
    db_fclose(f);
    db_fclose(f2);
    return;
  }
  printf("Converting file %s ......\n",file);
  str=(char*)db_malloc(2048);
  str2=(char*)db_malloc(2048);
  while (db_fgets(str,2048,f))
  {
    if (first && strncmp(str,"#define _DEBUG_",15))
    {
      fprintf(f3,"#define _DEBUG_ 1\n\n");
      fprintf(f3,"/* REMEMBER: You can use FinalCheck(); when you leave the program to\n");
      fprintf(f3,"   display memory leaks and open files */\n\n");
      fprintf(f3,"#include \"debug.h\"\n\n");
    }
    first=0;
    fprintf(f2,"%s",str);  
    y=0;
    while (functions[y])
    {
      sprintf(str2,"db_%s",functions[y]);
      ReplaceString(str,functions[y],str2);
      y++;
    }
    fprintf(f3,"%s",str);
  }
  db_fclose(f);
  db_fclose(f2);
  db_fclose(f3);
  db_rename(nw,file);
  db_free(str);
  db_free(str2);
}

int main(int argc,char *argv[])
{
  int x;
  
  for (x=1;x<argc;x++)
  {
    TranslateFile(argv[x]);
  }
  FinalCheck();
  return 0;
}

