#include <sys/time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <dirent.h>

void _db_log(char *str,...);
void _db_log2(char *str,...);
void _db_startprocedure(char *file,char *function,int line,char *str);
void _db_endprocedure(char *file,char *function,int line);
void *_db_malloc(int size,char *file,char *function,int line);
void _db_free(void *ptr,char *file,char *function,int line);
void *_db_realloc(void *ptr,int size,char *file,char *function,int line);
void *_db_calloc(int size,int n,char *file,char *function,int line);
char *_db_strcpy(char *str1,char *str2,char *file,char *function,int line);
char *_db_strncpy(char *str1,char *str2,int n,char *file,char *function,int line);
int _db_strcmp(char *str1,char *str2,char *file,char *function,int line);
char *_db_strdup(char *str1,char *file,char *function,int line);
void *_db_memchr(void *ptr,int chr,unsigned int n,char *file,char *function,int line);
int _db_memcmp(void *ptr1,void *ptr2,unsigned int n,char *file,char *function,int line);
void *_db_memcpy(void *ptr1,void *ptr2,unsigned int n,char *file,char *function,int line);
void *_db_memmove(void *ptr1,void *ptr2,unsigned int n,char *file,char *function,int line);
void *_db_memset(void *ptr,int chr,unsigned int n,char *file,char *function,int line);
char *_db_strcat(char *ptr1,char *ptr2,char *file,char *function,int line);
char *_db_strchr(char *ptr,int chr,char *file,char *function,int line);
int _db_strcspn(char *ptr1,char *ptr2,char *file,char *function,int line);
unsigned int _db_strlen(char *ptr,char *file,char *function,int line);
char *_db_strncat(char *ptr,char *ptr2,unsigned int n,char *file,char *function,int line);
int _db_strncmp(char *ptr,char *ptr2,unsigned int n,char *file,char *function,int line);
char *_db_strpbrk(char *ptr,char *ptr2,char *file,char *function,int line);
char *_db_strrchr(char *ptr,int chr,char *file,char *function,int line);
int _db_strspn(char *ptr,char *ptr2,char *file,char *function,int line);
char *_db_strstr(char *ptr,char *ptr2,char *file,char *function,int line);
char *_db_strtok(char *ptr,char *ptr2,char *file,char *function,int line);
void _db_setfileline(char *file,char *function,int line);
int _db_fprintf(FILE *f,char *str,...);
int _db_sprintf(char *s,char *str,...);

void _db_clearerr(FILE *file,char *filename,char *function,int line);
int _db_close(int file,char *filename,char *function,int line);
int _db_creat(char *file,int mode,char *filename,char *function,int line);
int _db_fclose(FILE *file,char *filename,char *function,int line);
int _db_feof(FILE *file,char *filename,char *function,int line);
int _db_ferror(FILE *file,char *filename,char *function,int line);
int _db_fflush(FILE *file,char *filename,char *function,int line);
int _db_fgetc(FILE *file,char *filename,char *function,int line);
char *_db_fgets(char *str,int num,FILE *file,char *filename,char *function,int line);
FILE *_db_fopen(char *file,char *mode,char *filename,char *function,int line);
int _db_fputc(int chr,FILE *file,char *filename,char *function,int line);
int _db_fputs(char *str,FILE *file,char *filename,char *function,int line);
int _db_fread(void *b,int s,int n,FILE *file,char *filename,char *function,int line);
FILE *_db_freopen(char *n,char *m,FILE *file,char *filename,char *function,int line);
int _db_fseek(FILE *file,long off,int or,char *filename,char *function,int line);
long _db_ftell(FILE *file,char *filename,char *function,int line);
int _db_fwrite(void *b,int s,int n,FILE *file,char *filename,char *function,int line);
int _db_getc(FILE *file,char *filename,char *function,int line);
long _db_lseek(int file,long off,int or,char *filename,char *function,int line);
int _db_open(char *file,int mode,char *filename,char *function,int line);
int _db_putc(int chr,FILE *file,char *filename,char *function,int line);
int _db_read(int file,char *buf,unsigned int cnt,char *filename,char *function,int line);
int _db_remove(char *file,char *filename,char *function,int line);
int _db_rename(char *file,char *tar,char *filename,char *function,int line);
void _db_rewind(FILE *file,char *filename,char *function,int line);
void _db_setbuf(FILE *file,char *buf,char *filename,char *function,int line);
int _db_setvbuf(FILE *file,char *b,int m,int s,char *filename,char *function,int line);
char *_db_tmpnam(char *file,char *filename,char *function,int line);
FILE *_db_tmpfile(char *filename,char *function,int line);
int _db_ungetc(int chr,FILE *file,char *filename,char *function,int line);
int _db_unlink(char *file,char *filename,char *function,int line);
int _db_write(int file,char *b,unsigned int n,char *filename,char *function,int line);

int _db_pipe(int files[2],char *filename,char *function,int line);
int _db_dup(int file,char *filename,char *function,int line);
int _db_dup2(int file,int f2,char *filename,char *function,int line);
FILE *_db_fdopen(int file,char *mode,char *filename,char *function,int line);
int _db_fstat(int file,struct stat *st,char *filename,char *function,int line);
int _db_lstat(char *file,struct stat *st,char *filename,char *function,int line);
int _db_stat(char *file,struct stat *st,char *filename,char *function,int line);
int _db_access(char *file,int st,char *filename,char *function,int line);
DIR *_db_opendir(char *file,char *filename,char *function,int line);
struct dirent *_db_readdir(DIR *file,char *filename,char *function,int line);
int _db_closedir(DIR *file,char *filename,char *function,int line);
int _db_chmod(char *file,mode_t st,char *filename,char *function,int line);
int _db_fchmod(int file,mode_t st,char *filename,char *function,int line);
int _db_chown(char *file,uid_t own,gid_t grp,char *filename,char *function,int line);
int _db_fchown(int file,uid_t own,gid_t grp,char *filename,char *function,int line);
int _db_chdir(char *file,char *filename,char *function,int line);
int _db_fchdir(int file,char *filename,char *function,int line);
int _db_rmdir(char *file,char *filename,char *function,int line);
int _db_truncate(char *file,size_t st,char *filename,char *function,int line);
int _db_ftruncate(int file,size_t st,char *filename,char *function,int line);
int _db_mkdir(char *file,mode_t st,char *filename,char *function,int line);
int _db_link(char *file,char *st,char *filename,char *function,int line);
int _db_select(int n,int *r,int *w,int *e,struct timeval *t,char *filename,char *function,int line);
FILE *_db_popen(char *cmd,char *st,char *filename,char *function,int line);
int _db_pclose(FILE *file,char *filename,char *function,int line);
int _db_socket(int file,int st,int re,char *filename,char *function,int line);
int _db_bind(int file,struct sockaddr *st,int re,char *filename,char *function,int line);
int _db_recv(int f,void *s,int n,unsigned int m,char *filename,char *function,int line);
int _db_send(int f,void *s,int n,unsigned int m,char *filename,char *function,int line);
int _db_listen(int file,int st,char *filename,char *function,int line);
int _db_shutdown(int file,int st,char *filename,char *function,int line);
int _db_accept(int file,struct sockaddr *st,int *re,char *filename,char *function,int line);
int _db_connect(int file,struct sockaddr *st,int re,char *filename,char *function,int line);
int _db_sendto(int f,void *s,int n,unsigned int m,struct sockaddr *a,int l,char *filename,char *function,int line);
int _db_recvfrom(int f,void *s,int n,unsigned int m,struct sockaddr *a,int *l,char *filename,char *function,int line);
char *_db_getcwd(char *file,size_t st,char *filename,char *function,int line);
int _db_scandir(char *f,struct dirent ***s,int (*n)(const struct dirent*),int (*m)(const struct dirent *,const struct dirent*),char *filename,char *function,int line);

