#include "dbgstack.h"
#include <stdio.h>
#include <stdlib.h>

Stack *_db_StackCreate()
{
  Stack *s;
  
  s=(Stack*)malloc(sizeof(Stack));
  s->last=NULL;
}

void _db_Push(Stack *s,char *file,char *str,int line)
{
  StackElem *se;
  
  se=(StackElem*)malloc(sizeof(StackElem));
  strncpy(se->func,str,31);
  strncpy(se->file,file,31);
  se->line=line;
  se->prev=s->last;
  s->last=se;
}

void _db_Pop(Stack *s)
{
  StackElem *se;
  
  se=s->last;
  if (se)
  {
    s->last=se->prev;
    free(se);
  }
}

void _db_StackDisplay(Stack *s)
{
  StackElem *se;
  
  if (!s)
    return;
  se=s->last;
  if (se)
  {
    printf("Procedure/Function calling stack:\n");
    _db_log2("Procedure/Function calling stack:\n");
    do
    {
      if (se->func[0])
      {
        printf("\tfile: %s\t\tline: %d\tfunction: %s()\n",se->file,se->line,se->func);
        _db_log2("\tfile: %s\t\tline: %d\tfunction: %s()\n",se->file,se->line,se->func);
      }        
      else
      {
        printf("\tfile: %s\t\tline: %d\n",se->file,se->line);
        _db_log2("\tfile: %s\t\tline: %d\n",se->file,se->line);
      }
      se=se->prev;
    } while (se);
  }
}
