#include <stdio.h>

extern void yyparse();
FILE *f;      /* Output stream */
int lineno=0;
int edit_mode;

void yyerror(char *str)
{
  printf("line %d: %s\n",lineno,str);
}

int main(int argc,char *argv[])
{
  int x,source=1;

  if (argc<2) /* No input file specified */
  {
    printf("Usage: pre source_file [target_file]\n");
    return 1;
  }
  f=stdout;
  for (x=1;x<argc;x++) /* Parse arguments */
  {
      if (source)
      {
	if (freopen(argv[x],"r",stdin)==NULL)
	   /* Redirect stdin to source file */
	{
	  fprintf(stderr,"\nCan't open file %s",argv[x]);
	  return 2;
	}
	source=0;
      }
      else
      {
	if ((f=fopen(argv[x],"w"))==NULL)
	  /* Create output file */
	{
	  fprintf(stderr,"\nCan't create target file %s",argv[x]);
	  return 3;
	}
      }
  }
  if (source) /* No source file specified */
  {
    printf("Usage: pre source_file [target_file]\n");
    return 3;
  }
  yyparse(); /* Parse program */
  fclose(stdin);
  if (argc==3)
    fclose(f);
  printf("\n");
  return 0;
}

