#include <Xm/MessageB.h>
#include <Xm/Text.h>
#include <ctype.h>
#include "jex.h"

extern Widget top;

void ClearSelection(Widget w,Editor *e,void *cbs)
{
  XmTextPosition f,l,x;
  char *str;

SP("ClearSelection");
  if (e->read_only)
  {
    EP;
    return;
  }
  WatchCursor(e,1);
  XmTextGetSelectionPosition(e->text,&f,&l);
  if (f==l)
  {
    WatchCursor(e,0);
EP;
    return;
  }
  str=XmTextGetSelection(e->text);
  for (x=0;x<l-f;x++)
  {
    if (str[x]!='\n')
      str[x]=' ';
  }
  XmTextReplace(e->text,f,l,str);
  XtFree(str);
  SetCurrentWidget(e->text);
  WatchCursor(e,0);
EP;
}

void CapsSelection(Widget w,Editor *e,void *cbs)
{
  XmTextPosition f,l,x;
  char *str;

SP("CapsSelection");
  if (e->read_only)
  {
    EP;
    return;
  }
  WatchCursor(e,1);
  XmTextGetSelectionPosition(e->text,&f,&l);
  if (f==l)
  {
    WatchCursor(e,0);
    EP;
    return;
  }
  str=XmTextGetSelection(e->text);
  for (x=0;x<l-f;x++)
  {
    if (str[x]!='\n')
      str[x]=toupper(str[x]);
  }
  XmTextReplace(e->text,f,l,str);
  XmTextSetSelection(e->text,f,l,0);
  XtFree(str);
  SetCurrentWidget(e->text);
  WatchCursor(e,0);
EP;
}

void LowsSelection(Widget w,Editor *e,void *cbs)
{
  XmTextPosition f,l,x;
  char *str;

SP("LowsSelection");
  if (e->read_only)
  {
    EP;
    return;
  }
  WatchCursor(e,1);
  XmTextGetSelectionPosition(e->text,&f,&l);
  if (f==l)
  {
    WatchCursor(e,0);
EP;
    return;
  }
  str=XmTextGetSelection(e->text);
  for (x=0;x<l-f;x++)
  {
    if (str[x]!='\n')
      str[x]=tolower(str[x]);
  }
  XmTextReplace(e->text,f,l,str);
  XmTextSetSelection(e->text,f,l,0);
  XtFree(str);
  SetCurrentWidget(e->text);
  WatchCursor(e,0);
EP;
}

int FindTextString(Editor *e,char *str,int start_over,int set_pos)
{
  static XmTextPosition pos=1,prev_pos=0,len=0;
  XmTextPosition f,l;
 
SP("FindTextString");
  XmTextGetSelectionPosition(e->text,&f,&l);
  if (f!=l && f && pos!=0)
    XmTextSetInsertionPosition(e->text,f+1); 
  if (XmTextFindString(e->text,XmTextGetInsertionPosition(e->text),str,XmTEXT_FORWARD,&pos))
  {
    prev_pos=pos;
    len=db_strlen(str);
    if (set_pos)
      XmTextShowPosition(e->text,pos);
    XmTextSetSelection(e->text,pos,pos+len,0);
    if (set_pos)
      XmTextSetInsertionPosition(e->text,pos+len);
EP;
    return 1;
  }
  else if (pos!=0 && start_over)
  {
    if (XmTextFindString(e->text,0,str,XmTEXT_FORWARD,&pos))
    {
      pos=0;
      if (set_pos)
        XmTextSetInsertionPosition(e->text,0);
EP;
      return FindTextString(e,str,1,set_pos);
    }
    else
    {
EP;    
      return 0;
    }
  }
EP;  
  return 0;
}

int FindReverseTextString(Editor *e,char *str,int start_over)
{
  static XmTextPosition pos=1,prev_pos=0,len=0;
  XmTextPosition f,l;
 
SP("FindReverseTextString");
  XmTextGetSelectionPosition(e->text,&f,&l);
  if (f!=l && f && pos!=XmTextGetLastPosition(e->text))
    XmTextSetInsertionPosition(e->text,f-1); 
  if (XmTextFindString(e->text,XmTextGetInsertionPosition(e->text),str,XmTEXT_BACKWARD,&pos))
  {
    prev_pos=pos;
    len=db_strlen(str);
    XmTextShowPosition(e->text,pos);
    XmTextSetSelection(e->text,pos,pos+len,0);
    if (pos)
      XmTextSetInsertionPosition(e->text,pos+len);
    else
      XmTextSetInsertionPosition(e->text,XmTextGetLastPosition(e->text));
EP;
    return 1;
  }
  else if (pos!=XmTextGetLastPosition(e->text) && start_over)
  {
    if (XmTextFindString(e->text,XmTextGetLastPosition(e->text),str,XmTEXT_BACKWARD,&pos))
    {
      pos=XmTextGetLastPosition(e->text);
      XmTextSetInsertionPosition(e->text,pos);
EP;
      return FindReverseTextString(e,str,1);
    }
    else
    {
EP;    
      return 0;
    }
  }
EP;
  return 0;
}

void ReplaceText(Editor *e,char *str)
{
  XmTextPosition f,l;
  
SP("ReplaceText");
  if (e->read_only)
  {
  EP;
    return;
  }
  XmTextGetSelectionPosition(e->text,&f,&l);
  XmTextReplace(e->text,f,l,str);
EP;
}

void CutText(Widget w,Editor *e,void *cbs)
{
SP("CutText");
  XmTextCut(e->text,0);
EP;
}

void CopyText(Widget w,Editor *e,void *cbs)
{
SP("CopyText");
  XmTextCopy(e->text,0);
EP;
}

void PasteText(Widget w,Editor *e,void *cbs)
{
SP("PasteText");
  if (e->read_only)
  {
    EP;
    return;
  }
  XmTextPaste(e->text);
EP;
}

void DeleteLine(Widget w,XAnyEvent *event,String *args,int *num_args)
{
  char *str;  
  XmTextPosition left,right;
  int len,selection=1;
  
SP("DeleteLine");
  XtVaGetValues(w,XmNvalue,&str,NULL);
  len=db_strlen(str);
  if (!XmTextGetSelectionPosition(w,&left,&right) || left==right)
  {
    left=right=XmTextGetInsertionPosition(w);
    selection=0;
  }
  while (left>0 && str[left-1]!='\0' && str[left-1]!='\n')
    left--;
  if ((right && str[right-1]!='\n') || right!=left)
    right--;
  while (right>=0 && right<len && str[right]!='\0' && str[right]!='\n')
    right++;
  if (right<len-1)
    right++;    
  else if (left)
    left--;
  if (left>=right)
  {
    XtFree(str);
EP;
    return;
  }
  XtFree(str);
  XmTextSetSelection(w,left,right,0);
  XmTextRemove(w);
EP;
}  

void NotFound(Editor *e,char *findstr)
{
  char str[200];
  XmString xstr;

SP("NotFound");
  if (db_strlen(findstr)>150)
    strcpy(str,"Search string not found!");
  else
    sprintf(str,"String '%s' not found!",findstr);
  xstr=XmStringCreateLocalized(str);
  if (e->fd==NULL)
  {
    e->fd=XmCreateWarningDialog(e->shell,"NotFound",NULL,0);
    XtUnmanageChild(XmMessageBoxGetChild(e->fd,XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(e->fd,XmDIALOG_HELP_BUTTON));
  }
  XtVaSetValues(e->fd,XmNmessageString,xstr,NULL);
  XmStringFree(xstr);
  XtManageChild(e->fd);
EP;
}

void FindDown(Widget w,Editor *e,void *cbs)
{
  char *str,*str2;

SP("FindDown");
  WatchCursor(e,1);
  XtVaGetValues(e->findf,XmNvalue,&str,NULL);
  if (str[0])
  {
    UpdateComboBox(e->findf,str);
    if (FindTextString(e,str,0,1)==0)
      NotFound(e,str);
  }
  else
  {
    str2=XmTextGetSelection(e->text);
    if (str2)
    {
      if (FindTextString(e,str2,0,1)==0)
        NotFound(e,str2);
      XtFree(str2);
    }
  }    
  XtFree(str);
  WatchCursor(e,0);
EP;
}

void FindUp(Widget w,Editor *e,void *cbs)
{
  char *str,*str2;
  int x;

SP("FindUp");
  WatchCursor(e,1);
  XtVaGetValues(e->findf,XmNvalue,&str,NULL);
  if (str[0])
  {
    for (x=0;x<editors;x++)
      UpdateComboBox(editor[0]->findf,str);
/*    UpdateFindList(str);*/
    if (FindReverseTextString(e,str,0)==0)
      NotFound(e,str);
  }
  else
  {
    str2=XmTextGetSelection(e->text);
    if (str2)
    {
      if (FindReverseTextString(e,str2,0)==0)
        NotFound(e,str2);
      XtFree(str2);
    }
  }    
  XtFree(str);
  WatchCursor(e,0);
EP;
}

void Replace(Widget w,Editor *e,void *cbs)
{
  char *findstr,*replstr;
  XmTextPosition f,l;
  int x;

SP("Replace");
  if (e->read_only)
  {
    EP;
    return;
  }
  WatchCursor(e,1);
  XtVaGetValues(e->findf,XmNvalue,&findstr,NULL);
  XtVaGetValues(e->replf,XmNvalue,&replstr,NULL);
  XmTextGetSelectionPosition(e->text,&f,&l);
  if (w)
  {
/*    UpdateReplList(replstr);
    UpdateFindList(findstr);*/
    for (x=0;x<editors;x++)
    {
      UpdateComboBox(editor[0]->findf,findstr);
      UpdateComboBox(editor[0]->replf,replstr);
    }
  }
  if (f!=l)
    ReplaceText(e,replstr);
  if (findstr[0])
    FindTextString(e,findstr,0,((int)cbs==-1)?0:1);
  XtFree(findstr);
  XtFree(replstr);
  WatchCursor(e,0);
EP;
}

void ReplaceAll(Widget w,Editor *e,void *cbs)
{
  char *findstr,*replstr;
  XmTextPosition f,l;
  int x;

SP("ReplaceAll");
  if (e->read_only)
  {
    EP;
    return;
  }
  WatchCursor(e,1);
  XtVaGetValues(e->findf,XmNvalue,&findstr,NULL);
  XtVaGetValues(e->replf,XmNvalue,&replstr,NULL);
  XmTextGetSelectionPosition(e->text,&f,&l);
  for (x=0;x<editors;x++)
  {
    UpdateComboBox(editor[0]->findf,findstr);
    UpdateComboBox(editor[0]->replf,replstr);
  }
/*  UpdateReplList(replstr);
  UpdateFindList(findstr);*/
  if (db_strcmp(findstr,replstr)!=0)
  {
    if (f==l)
    {
      FindTextString(e,findstr,0,0);
      XmTextGetSelectionPosition(e->text,&f,&l);
    }
    while (f!=l)
    {
      Replace(NULL,e,(void*)-1);
      XmTextGetSelectionPosition(e->text,&f,&l);
    }
  }
  XtFree(findstr);
  XtFree(replstr);
  WatchCursor(e,0);
EP;
}
