#include "jex.h"
#include <Xm/List.h>
#include <Xm/MessageB.h>

Widget edd=NULL,edl;
extern Widget top;
extern Pixmap pixmap;

void CloseEditors(Widget w,void *e,void *cbs)
{
SP("CloseEditors");
/*  XtUnmanageChild(edd);*/
  XtPopdown(edd);
EP;
}

void GotoEditor(Widget w,void *data,XmListCallbackStruct *cbs)
{
  int pos_count;
  int *positions;
  
SP("GotoEditor");
  if (XmListGetSelectedPos(edl,&positions,&pos_count))
  {
    if (positions[0]<=editors)
      XMapRaised(XtDisplay(editor[positions[0]-1]->shell),XtWindow(editor[positions[0]-1]->shell));
    XtFree((char*)positions);
  }      
EP;
}

void CreateEditorDialog(void)
{
  Widget w;
  Arg arg[2];

SP("CreateEditorDialog");
  if (edd==NULL)
  {
    edd=XtVaAppCreateShell("EditorsDialog","EditorsDialog",topLevelShellWidgetClass,XtDisplay(top),
  	XmNallowShellResize,True,
    	XmNiconPixmap,pixmap,
  	NULL);
    w=XmCreateMessageBox(edd,"EditorsDialog",NULL,0);
    XtSetArg(arg[0],XmNlistSizePolicy,XmCONSTANT);
    edl=XmCreateScrolledList(w,"EditorList",arg,1);
    XtVaSetValues(XtParent(edl),
    	XmNscrollBarDisplayPolicy,XmSTATIC,
    	NULL);
    XtVaSetValues(edl,
    	XmNscrollBarDisplayPolicy,XmSTATIC,
    	XmNlistSizePolicy,XmCONSTANT,
    	NULL);
    XtAddCallback(edl,XmNdefaultActionCallback,(XtCallbackProc)GotoEditor,NULL);
/*    XtUnmanageChild(XmMessageBoxGetChild(w,XmDIALOG_HELP_BUTTON));*/
    XtAddCallback(w,XmNokCallback,(XtCallbackProc)CloseEditors,NULL);
    XtAddCallback(w,XmNcancelCallback,(XtCallbackProc)GotoEditor,NULL);
    XtAddCallback(w,XmNhelpCallback,(XtCallbackProc)Help,"Editors");
    XtManageChild(edl);
    XtManageChild(w);
  }
EP;
}

void UpdateEditorDialog(void)
{
  int x;
  XmString xstr;
  
SP("UpdateEditorDialog");
  if (edl)
  {
    XtUnmanageChild(edl);
    XmListDeleteAllItems(edl);
    for (x=0;x<editors;x++)
    {
      if (editor[x]->filename[0])
        xstr=XmStringCreateLocalized(editor[x]->filename);
      else
        xstr=XmStringCreateLocalized("<Untitled>");
      XmListAddItemUnselected(edl,xstr,0);
      XmStringFree(xstr);
    }
    XtManageChild(edl);
  }
EP;
}

void ShowEditorDialog(void)
{
SP("ShowEditorDialog");
  if (!edd)
  {
    CreateEditorDialog();
    UpdateEditorDialog();
  }
/*  XtManageChild(edd);*/
  XtPopup(edd,XtGrabNone);
  XMapRaised(XtDisplay(edd),XtWindow(edd));
EP;
}

