#include <Xm/Xm.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/DialogS.h>
#include <Xm/List.h>
#include <Xm/MessageB.h>
#include <Xm/Form.h>
#include <Xm/LabelG.h>
#include <Xm/PushBG.h>
#include <Xm/Separator.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <signal.h>
#include <sys/param.h>
#include <sys/file.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <sys/wait.h>
#include <sys/resource.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include "jex.h"

extern Widget top;
extern XtAppContext app;
extern Pixmap pixmap;

#define WORKTIMEOUT 150
#define WORKCOUNTS 20
/*char *workstr[]={"|","/","-","\\"};*/
char *workstr[]={
"/.........",
"./........",
"../.......",
".../......",
"..../.....",
"...../....",
"....../...",
"......./..",
"......../.",
"........./",
".........\\",
"........\\.",
".......\\..",
"......\\...",
".....\\....",
"....\\.....",
"...\\......",
"..\\.......",
".\\........",
"\\........."
};

void InputCallback1(Editor *e,int f,XtInputId l);
void InputCallback2(Editor *e,int f,XtInputId l);

void SetLabel(Editor *e,...)
{
  va_list app;
  char str[255],*tmp;
  XmString xstr;
  
SP("SetLabel");
  va_start(app,e);
  tmp=va_arg(app,char *);
  vsprintf(str,tmp,app);
  va_end(app);
  xstr=XmStringCreateLtoR(str,XmSTRING_DEFAULT_CHARSET);
  XtVaSetValues(e->iodtext,XmNlabelString,xstr,NULL);
  XmStringFree(xstr);
EP;
}

void wprintf(Widget window,...)
{
  va_list app;
  char str[512],*tmp;
  XmString xstr;

SP("wprintf");
  va_start(app,window);
/*  if (!XtIsManaged(XtParent(XtParent(XtParent(window)))))
    XtManageChild(XtParent(XtParent(XtParent(window))));*/
/*  XtPopup(XtParent(XtParent(XtParent(window))),XtGrabNone);*/
  tmp=va_arg(app,char *);
  vsprintf(str,tmp,app);
  va_end(app);
  xstr=XmStringCreateLtoR(str,XmSTRING_DEFAULT_CHARSET);
  XmListAddItemUnselected(window,xstr,0);
  XmListSetBottomPos(window,0);
  XmStringFree(xstr);
EP;
}

void SplitUp(char *str,char *list[])
{
SP("SplitUP");
  while (*str!=0)
  {
    while ((*str==' ') || (*str=='\t') || (*str=='\n'))
      *(str++)=0;
    *(list++)=str;
    while ((*str!=0) && (*str!=' ') && (*str!='\t') && (*str!='\n'))
      str++;
  }
  *list=0;
EP;
}

void RemoveInputs(Editor *e,void *tid)
{
SP("RemoveInputs");
  XtRemoveInput(e->t.id);  
  XtRemoveInput(e->t.id2);
  db_close(e->t.fd[0]); 
  db_close(e->t.fd[1]);
  db_close(e->t.fd2[0]);
  db_close(e->t.fd2[1]);
  db_close(e->t.fd3[0]);
  db_close(e->t.fd3[1]);
EP;
}  

void FreeClose(int sig,XtIntervalId tid)
{
  int status,pid=0,x,y;

SP("FreeClose");
  for (y=0;y<editors;y++)
  {
    if (editor[y]->t.pid)
    {
      if ((pid=waitpid(editor[y]->t.pid,&status,WNOHANG))==-1)
      {
        EP;
        return;
      }
      else
      {
        if (pid)
        {
          for (x=0;x<editors;x++)
          {
            if (editor[x]->t.pid==pid)
            {
              XtAppAddTimeOut(app,0,(XtTimerCallbackProc)RemoveInputs,editor[x]);
              if (sig)
              {
                InputCallback1(editor[x],0,0);
                InputCallback2(editor[x],0,0);
              }
              if (editor[x]->x)
              {
                editor[x]->buf[editor[x]->x]=0;
                wprintf(editor[x]->io_win,"%s",editor[x]->buf);
              }
              if (WIFEXITED(status)!=0) 
              {
                if (WEXITSTATUS(status)==0)
                  SetLabel(editor[x],"%s has finished normally.",editor[x]->t.name);
                else
                  SetLabel(editor[x],"%s has finished with error code %d.",
                      editor[x]->t.name,WEXITSTATUS(status));
              }
              else if (WIFSIGNALED(status)) 
                SetLabel(editor[x],"%s has finished abnormally!! (signal %d)",
                    editor[x]->t.name,WTERMSIG(status));
              else
                SetLabel(editor[x],"%s has finished abnormally for an unknown reason!!",
                      editor[x]->t.name);
              XtVaSetValues(editor[x]->compile,XmNsensitive,True,NULL);  
              XtVaSetValues(editor[x]->make,XmNsensitive,True,NULL);  
              XtVaSetValues(editor[x]->run,XmNsensitive,True,NULL);  
              XtVaSetValues(editor[x]->grep,XmNsensitive,True,NULL);  
      #ifndef LESSTIFF        
              XtVaSetValues(XtNameToWidget(editor[x]->mb,"*toolsmenu.button_0"),XmNsensitive,True,NULL);
              XtVaSetValues(XtNameToWidget(editor[x]->mb,"*toolsmenu.button_1"),XmNsensitive,True,NULL);
              XtVaSetValues(XtNameToWidget(editor[x]->mb,"*toolsmenu.button_2"),XmNsensitive,True,NULL);
              XtVaSetValues(XtNameToWidget(editor[x]->mb,"*toolsmenu.button_3"),XmNsensitive,True,NULL);
      #endif
              if (editor[x]->tid)
              {
                XtRemoveTimeOut(editor[x]->tid);
                editor[x]->tid=0;
              }
              editor[x]->t.pid=0;
            }
          }
        }
      }
    }
  }
EP;
}

void ChildSignal(int sig)
{
  SP("ChildSignal");
  XtAppAddTimeOut(app,0,(XtTimerCallbackProc)FreeClose,(void*)sig);
  EP;
}
  
void InputTimeout1(Editor *e,XtIntervalId tid)
{
  
SP("InputTimeout1");
  if (e->x)
  {
    if (e->same_line)
      XmListDeletePos(e->io_win,0);
    e->buf[e->x]=0;
    wprintf(e->io_win,e->buf);
    e->same_line=1;
  }
  e->tid7=0;
EP;
}

void InputCallback1(Editor *e,int f,XtInputId l)
{
  unsigned int bread;

SP("InputCallback1");
  if (e->tid7)
    XtRemoveTimeOut(e->tid7);
  e->tid7=XtAppAddTimeOut(app,250,(XtTimerCallbackProc)InputTimeout1,e);
  while ((bread=read(e->t.fd[0],&e->buf[e->x],1))==1)
  {
    if (e->x+1==BUFSIZE-1 || e->buf[e->x]=='\n')
    {
      if (e->buf[e->x]=='\n')
        e->buf[e->x]='\0'; /* Make sure string is 0-terminated. */
      else
        e->buf[e->x+1]='\0'; /* Make sure string is 0-terminated. */
      wprintf(e->io_win,"%s",e->buf);
      e->same_line=0;
      e->x=0;
    }
    else
    {
      e->x++;
    }
  }
  if (bread==-1 && l==0)
    FreeClose(0,0);
EP;
}

void InputCallback2(Editor *e,int f,XtInputId l)
{
  unsigned int bread;

SP("InputCallback2");
  if (e->tid7)
    XtRemoveTimeOut(e->tid7);
  e->tid7=XtAppAddTimeOut(app,250,(XtTimerCallbackProc)InputTimeout1,e);
  while ((bread=read(e->t.fd2[0],&e->buf[e->x],1))==1)
  {
    if (e->x+1==BUFSIZE-1 || e->buf[e->x]=='\n')
    {
      if (e->buf[e->x]=='\n')
        e->buf[e->x]='\0'; /* Make sure string is 0-terminated. */
      else
        e->buf[e->x+1]='\0'; /* Make sure string is 0-terminated. */
      wprintf(e->io_win,"%s",e->buf);
      e->x=0;
    }
    else
      e->x++;
  }
  if (bread==-1 && l==0)
    FreeClose(0,0);
EP;
}

void CloseCompile(Widget w,Editor *e,void *cbs)
{
SP("CloseCompile");
/*  XtUnmanageChild(e->iod);*/
  XtPopdown(e->iod);
  SetCurrentWidget(e->text);
EP;
}

void CheckChild(int pid,XtIntervalId tid)
{
  int status,result;

  SP("CheckChild");
  result=waitpid(pid,&status,WNOHANG);
  if (result>=0)
  {
    kill(pid,SIGKILL);
  }
  EP;
}

void StopCompile(Widget w,Editor *e,void *cbs)
{
SP("StopCompile");
  if (e->t.pid)
  {
    kill(e->t.pid,SIGQUIT);
    SetLabel(e,"Sent quit signal to program...");
    XtAppAddTimeOut(app,5000,(XtTimerCallbackProc)CheckChild,(void*)e->t.pid);
    if (e->tid)
    {
      XtRemoveTimeOut(e->tid);
      e->tid=0;
    }
  }
EP;
}

void SendInput(Widget w,Editor *e,void *cbs)
{
  char *tmpstr;
  
SP("SendInput");
  if (e->t.pid)
  {
    XtVaGetValues(e->owi,XmNvalue,&tmpstr,NULL);
    write(e->t.fd3[1],tmpstr,strlen(tmpstr));
    write(e->t.fd3[1],"\n",strlen("\n"));
    if (strlen(e->buf)+strlen(tmpstr)<BUFSIZE)
    {
      if (e->same_line)
        XmListDeletePos(e->io_win,0);
      strcat(e->buf,tmpstr);
      wprintf(e->io_win,"%s",e->buf);
      e->x=0;
      e->same_line=0;
    }
    XtFree(tmpstr);
    XmTextFieldSetString(e->owi,""); // Clear the textfield.
  }
EP;
}

void CreateOutputWindow(Editor *e)
{
  Widget w,w2,w3;
  Arg arg[9];
  Dimension height;

SP("CreateOutputWindow");
  if (!e->iod)
  {
/*    e->iod=XtVaCreateManagedWidget("IODialog",topLevelShellWidgetClass,top,
    	XmNallowShellResize,False,
    	XmNiconPixmap,pixmap,
    	NULL);*/
    e->iod=XtVaAppCreateShell("IODialog","IODialog",topLevelShellWidgetClass,XtDisplay(top),
  	XmNallowShellResize,False,
    	XmNiconPixmap,pixmap,
  	NULL);
    w2=XtVaCreateManagedWidget("IODialogForm",xmFormWidgetClass,e->iod,
    	NULL);
    e->iodtext=XtVaCreateManagedWidget("IODialogText",xmLabelGadgetClass,w2,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNbottomAttachment,XmATTACH_NONE,
	XmNalignment,XmALIGNMENT_CENTER,
    	NULL);
    	
    w3=XtVaCreateManagedWidget("IOButtons",xmFormWidgetClass,w2,    	
    	XmNtopAttachment,XmATTACH_NONE,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNbottomAttachment,XmATTACH_FORM,
    	XmNfractionBase,9,
    	XmNbottomOffset,10,
    	NULL);
    w=XtVaCreateManagedWidget("IO_OK",xmPushButtonGadgetClass,w3,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNleftAttachment,XmATTACH_POSITION,
    	XmNleftPosition,1,
    	XmNrightAttachment,XmATTACH_POSITION,
    	XmNrightPosition,2,
    	XmNbottomAttachment,XmATTACH_FORM,
	NULL);    	
    XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)CloseCompile,e);
    w=XtVaCreateManagedWidget("IO_Stop",xmPushButtonGadgetClass,w3,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNleftAttachment,XmATTACH_POSITION,
    	XmNleftPosition,3,
    	XmNrightAttachment,XmATTACH_POSITION,
    	XmNrightPosition,4,
    	XmNbottomAttachment,XmATTACH_FORM,
	NULL);    	
    XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)StopCompile,e);
    
    w=XtVaCreateManagedWidget("IO_Goto",xmPushButtonGadgetClass,w3,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNleftAttachment,XmATTACH_POSITION,
    	XmNleftPosition,5,
    	XmNrightAttachment,XmATTACH_POSITION,
    	XmNrightPosition,6,
    	XmNbottomAttachment,XmATTACH_FORM,
	NULL);    	
    XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)GotoError,e);
    
    w=XtVaCreateManagedWidget("IO_Help",xmPushButtonGadgetClass,w3,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNleftAttachment,XmATTACH_POSITION,
    	XmNleftPosition,7,
    	XmNrightAttachment,XmATTACH_POSITION,
    	XmNrightPosition,8,
    	XmNbottomAttachment,XmATTACH_FORM,
	NULL);    	
    XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)Help,"OutputWindow");
    
    w=XtVaCreateManagedWidget("IOSep",xmSeparatorWidgetClass,w2,
    	XmNtopAttachment,XmATTACH_NONE,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNbottomAttachment,XmATTACH_WIDGET,
    	XmNbottomWidget,w3,
    	XmNorientation,XmHORIZONTAL,
    	XmNbottomOffset,10,
    	NULL);

    w3=XtVaCreateManagedWidget("IOInputLabel",xmLabelGadgetClass,w2,
    	XmNtopAttachment,XmATTACH_NONE,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNrightAttachment,XmATTACH_NONE,
    	XmNbottomAttachment,XmATTACH_WIDGET,
    	XmNbottomWidget,w,
    	NULL);

    e->owi=XtVaCreateManagedWidget("IOInputField",xmTextFieldWidgetClass,w2,
    	XmNtopAttachment,XmATTACH_NONE,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,w3,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNbottomAttachment,XmATTACH_WIDGET,
    	XmNbottomWidget,w,
    	NULL);
    XtAddCallback(e->owi,XmNactivateCallback,(XtCallbackProc)SendInput,e);
    XtVaGetValues(e->owi,XmNheight,&height,NULL);
    XtVaSetValues(w3,XmNheight,height,NULL);

    XtSetArg(arg[0],XmNtopAttachment,XmATTACH_WIDGET);
    XtSetArg(arg[1],XmNtopWidget,e->iodtext);
    XtSetArg(arg[2],XmNleftAttachment,XmATTACH_FORM);
    XtSetArg(arg[3],XmNrightAttachment,XmATTACH_FORM);
    XtSetArg(arg[4],XmNbottomAttachment,XmATTACH_WIDGET);
    XtSetArg(arg[5],XmNbottomWidget,e->owi);
    XtSetArg(arg[6],XmNlistSizePolicy,XmCONSTANT);
    XtSetArg(arg[7],XmNbottomOffset,10);
    XtSetArg(arg[8],XmNtopOffset,10);
    e->io_win=XmCreateScrolledList(w2,"IOList",arg,9);
    XtVaSetValues(e->io_win,
    	XmNscrollBarDisplayPolicy,XmSTATIC,
    	XmNlistSizePolicy,XmCONSTANT,
    	NULL);
    XtAddCallback(e->io_win,XmNdefaultActionCallback,(XtCallbackProc)GotoError,(void*)e);

    XtManageChild(e->io_win);
  }
EP;
}

void SetWorkingLabel(Editor *e,void *t)
{
SP("SetWorkingLabel");
  e->workcount=(e->workcount+1)%WORKCOUNTS;
  SetLabel(e,workstr[e->workcount]);
  e->tid=XtAppAddTimeOut(app,WORKTIMEOUT,(XtTimerCallbackProc)SetWorkingLabel,e);
EP;
}

void ExecProg(Editor *e,char *_prog)
{
  static char *command[20];
  char *prog;
  int pid;

SP("ExecProg");
  WatchCursor(e,1);
  XtVaSetValues(e->compile,XmNsensitive,False,NULL);  
  XtVaSetValues(e->make,XmNsensitive,False,NULL); 
  XtVaSetValues(e->run,XmNsensitive,False,NULL); 
  XtVaSetValues(e->grep,XmNsensitive,False,NULL);
#ifndef LESSTIFF    
  XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,False,NULL);
#endif
  CreateOutputWindow(e); 
/* XtManageChild(e->iod);*/
  XtPopup(e->iod,XtGrabNone);
  XMapRaised(XtDisplay(e->iod),XtWindow(e->iod));
  XmListDeleteAllItems(e->io_win);
  e->x=0;
  WatchCursor(e,0);
  
  if (db_pipe(e->t.fd)!=0)
  {
    SetLabel(e,"Too many open files!");
    XtVaSetValues(e->compile,XmNsensitive,True,NULL);  
    XtVaSetValues(e->make,XmNsensitive,True,NULL);  
    XtVaSetValues(e->run,XmNsensitive,True,NULL);  
    XtVaSetValues(e->grep,XmNsensitive,True,NULL);  
#ifndef LESSTIFF    
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,True,NULL);
#endif
EP;
    return;
  }
  if (db_pipe(e->t.fd2)!=0)
  {
    SetLabel(e,"Too many open files!");
    db_close(e->t.fd[0]);
    db_close(e->t.fd[1]);
    XtVaSetValues(e->compile,XmNsensitive,True,NULL);
    XtVaSetValues(e->make,XmNsensitive,True,NULL);
    XtVaSetValues(e->run,XmNsensitive,True,NULL);
    XtVaSetValues(e->grep,XmNsensitive,True,NULL);  
#ifndef LESSTIFF    
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,True,NULL);
#endif
EP;
    return;
  }
  if (db_pipe(e->t.fd3)!=0)
  {
    SetLabel(e,"Too many open files!");
    db_close(e->t.fd[0]);
    db_close(e->t.fd[1]);
    db_close(e->t.fd2[0]);
    db_close(e->t.fd2[1]);
    XtVaSetValues(e->compile,XmNsensitive,True,NULL);
    XtVaSetValues(e->make,XmNsensitive,True,NULL);
    XtVaSetValues(e->run,XmNsensitive,True,NULL);
    XtVaSetValues(e->grep,XmNsensitive,True,NULL);  
#ifndef LESSTIFF    
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,True,NULL);
#endif
EP;
    return;
  }

  prog=(char*)db_malloc(db_strlen(_prog)*2); 
  db_strcpy(prog,_prog);			 
  SetLabel(e,"%s",prog);
  e->tid=XtAppAddTimeOut(app,500,(XtTimerCallbackProc)SetWorkingLabel,(void*)e);
  e->same_line=0;

  fcntl(e->t.fd[0],F_SETFL,O_NONBLOCK);
  fcntl(e->t.fd2[0],F_SETFL,O_NONBLOCK);

  e->t.id=XtAppAddInput(app,e->t.fd[0],(XtPointer)XtInputReadMask,(XtInputCallbackProc)InputCallback1,(XtPointer)e);
  e->t.id2=XtAppAddInput(app,e->t.fd2[0],(XtPointer)XtInputReadMask,(XtInputCallbackProc)InputCallback2,(XtPointer)e);

  SplitUp(prog,command);
  db_strncpy(e->t.name,command[0],99);
  signal(SIGCHLD,ChildSignal);

  if ((pid=fork())>=0)
  {
    if (pid>0)
    {
      e->t.pid=pid;
      db_free(prog);
      e->grepped=0;
    }
    if (pid==0)
    {
      db_dup2(e->t.fd3[0],0);
      db_dup2(e->t.fd[1],1);
      db_dup2(e->t.fd2[1],2);
      if (execvp(command[0],command)==-1)
        exit(-1);
      exit(0);
    }
  }
  else
  {
    SetLabel(e,"fork() failed!");
    XtVaSetValues(e->compile,XmNsensitive,True,NULL);  
    XtVaSetValues(e->make,XmNsensitive,True,NULL);  
    XtVaSetValues(e->run,XmNsensitive,True,NULL);  
    XtVaSetValues(e->grep,XmNsensitive,True,NULL);  
#ifndef LESSTIFF    
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_0"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_1"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_2"),XmNsensitive,True,NULL);
    XtVaSetValues(XtNameToWidget(e->mb,"*toolsmenu.button_3"),XmNsensitive,True,NULL);
#endif
EP;
    return;
  }
EP;
}

void CompileOK(Editor *e)
{
  char str[255];
  
SP("CompileOK");
  sprintf(str,e->compile_command,e->filename);
  ExecProg(e,str);
EP;
}

void Compile(Widget w,Editor *e,void *cbs)
{
  int x;
  
SP("Compile");
  for (x=0;x<editors;x++)
  {
    if (!editor[x]->saved  && editor[x]->filename[0])
      Save(NULL,editor[x],NULL);
  }
  if (e->saved && e->filename[0])
    CompileOK(e);
  else
    Save(NULL,e,(void*)CompileOK);
EP;
}

void MakeOK(Editor *e)
{
SP("MakeOK");
  ExecProg(e,e->make_command);
EP;
}

void Make(Widget w,Editor *e,void *cbs)
{
  int x;
  
SP("Make");
  for (x=0;x<editors;x++)
  {
    if (!editor[x]->saved  && editor[x]->filename[0])
      Save(NULL,editor[x],NULL);
  }
  if (e->saved && e->filename[0])
    MakeOK(e);
  else
    Save(NULL,e,(void*)MakeOK);
EP;
}

void LatestVersion(void)
{
  char *cmd[3];
  char browser[256];
  
  if (!FindHelpFile("netscape",browser))
  {
    if (!FindHelpFile("Mosaic",browser))
    {
      if (!FindHelpFile("arena",browser))
      {
	HelpError("You can find the latest version at http://www.club.innet.be/~year1939/applications.html");
	return;
      }
    }
  }
  if (!fork())
  {
    cmd[0]=strdup(browser);
    cmd[1]=strdup("http://www.club.innet.be/~year1939/applications.html");
    cmd[2]=NULL;
    if (execvp(cmd[0],cmd)==-1)
      exit(-1);
    exit(0);
  }
}

void RunOK(Editor *e)
{
  char runstr[1000];
  
SP("Run");
  sprintf(runstr,e->run_command,e->filename);
  ExecProg(e,runstr);
EP;
}

void Run(Widget w,Editor *e,void *cbs)
{
SP("Run");
  if (!e->run_command[0])
    ShowError(e,"You must specify in the settings which program to run!");
  else
  {
    if (e->saved && e->filename[0])
      RunOK(e);
    else
      Save(NULL,e,(void*)RunOK);
  }
EP;
}
