#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include "jex.h"

extern char fl_files[FILELIST][255];

void Quit(Widget w,Editor *e,void *cbs)
{
SP("Quit");
  if (e->saved)
    Exit(e);
  else
    AskToSave(e,(void*)Exit);
EP;
}  

void DoNew(Widget *w,Editor *e,void *cbs)
{  
  SP("DoNew");
  if (e->saved)
    New(e);
  else
    AskToSave(e,(void*)New);
  EP;
}

void DoOpen(Widget *w,Editor *e,void *cbs)
{  
  SP("DoOpen");
  if (e->saved)
    Load(e);
  else
    AskToSave(e,(void*)Load);
  EP;
}

void DoNewWindow(Widget *w,void *e,void *cbs)
{  
  SP("DoNewWindow");
  CreateNewEditor();
  EP;
}

void DoClone(Widget *w,Editor *e,void *cbs)
{  
  SP("DoClone");
  CreateNewEditor();
  if (e->filename[0])
  {
    if (loadfile(editor[editors-1],e->filename,0,1))
      LoadError(editor[editors-1]);
  }
  EP;
}

void file_cb(Widget w,int item,void *cbs)
{
  int x;

SP("file_cb");
  for (x=0;x<editors;x++)
  {
    if (editor[x]->mb==XtParent(XtParent(XtParent(w))))
    {
      switch (item)
      {
        case 0: /* New window */
	    CreateNewEditor();
            break;
        case 1: /* New window */
	    CreateNewEditor();
	    if (editor[x]->filename[0])
	    {
              if (loadfile(editor[editors-1],editor[x]->filename,0,1))
                LoadError(editor[editors-1]);
            }
            break;
        case 2: /* New */
            if (editor[x]->saved)
     	      New(editor[x]);
            else
              AskToSave(editor[x],(void*)New);
            break;
        case 3: /* Load */
            if (editor[x]->saved)
     	      Load(editor[x]);
            else
              AskToSave(editor[x],(void*)Load);
            break;
        case 4: 
            Save(NULL,editor[x],NULL);
            break;
        case 5: 
            editor[x]->func2=NULL;
            SaveAs(editor[x]);
            break;
        case 6: 
            Reload(editor[x]);
            break;
        case 7: 
            Revert(editor[x]);
            break;
        case 8: 
            Insert(editor[x]);
            break;
        case 9: 
            Print(editor[x]);
            break;
        case 10: 
            Quit(NULL,editor[x],NULL);
            break;
      }
    }
  }
EP;
}

void edit_cb(Widget w,int item,void *cbs)
{
  int x;
  
SP("edit_cb");
  for (x=0;x<editors;x++)
  {
    if (editor[x]->mb==XtParent(XtParent(XtParent(w))))
    {
      switch (item)
      {
        case 0:
            UndoAction(NULL,editor[x],NULL);
            break;
        case 1:
            RedoAction(NULL,editor[x],NULL);
            break;
        case 2:
            RepeatAction(NULL,editor[x],NULL);
            break;
        case 3:
            CopyText(NULL,editor[x],NULL);
            break;
        case 4:
            CutText(NULL,editor[x],NULL);
            break;
        case 5:
            PasteText(NULL,editor[x],NULL);
            break;
        case 6:
            ClearSelection(NULL,editor[x],NULL);
            break;
        case 7:
            CapsSelection(NULL,editor[x],NULL);
            break;
        case 8:
            LowsSelection(NULL,editor[x],NULL);
            break;
        case 9:
            ShiftLeft(NULL,editor[x],NULL);
            break;
        case 10:
            ShiftRight(NULL,editor[x],NULL);
            break;
        case 11:
            FindMatchingChar(NULL,editor[x],NULL);
            break;
        case 12:
            SetMarker(NULL,editor[x],NULL);
            break;
        case 13:
            GotoMarker(NULL,editor[x],NULL);
            break;
      }
    }
  }
EP;
}

void PopupMenu(Widget w,XButtonPressedEvent *event,String *args,int *num_args)
{
  int x;
  
SP("PopupMenu");
  while (!XtIsShell(w))
    w=XtParent(w);
  for (x=0;x<editors;x++)
  {
    if (editor[x]->shell==w)
    {
      XmMenuPosition(editor[x]->pm,event);
      XtManageChild(editor[x]->pm);
    }
  }
EP;
}

void popup_cb(Widget w,int item,XmAnyCallbackStruct *cbs)
{
  int x;
  
SP("popup_cb");
  for (x=0;x<editors;x++)
  {
    if (editor[x]->pm==XtParent(w))
    {
      switch ((int)item)
      {
        case 0:
            CopyText(NULL,editor[x],NULL);
            break;
        case 1:
            CutText(NULL,editor[x],NULL);
            break;
        case 2:
            PasteText(NULL,editor[x],NULL);
            break;
        case 3:
            ClearSelection(NULL,editor[x],NULL);
            break;
        case 4:
            UndoAction(NULL,editor[x],NULL);
            break;
        case 5:
            RedoAction(NULL,editor[x],NULL);
            break;
        case 6:
            GotoLine(NULL,editor[x],NULL);
            break;
      }
    }
  }
EP;
}


void option_cb(Widget w,int item,void *cbs)
{
  int x;
  Boolean set;
  
SP("option_cb");
  for (x=0;x<editors;x++)
  {
    if (editor[x]->mb==XtParent(XtParent(XtParent(w))))
    {
      switch (item)
      {
        case 0: Settings(editor[x]);break;
        case 1: XtVaGetValues(w,XmNset,&set,NULL);
        	XtVaSetValues(editor[x]->text,XmNeditable,set?False:True,NULL);
        	editor[x]->read_only=set?1:0;
        	break;
        case 3: Compile(NULL,editor[x],NULL);break;
        case 4: Make(NULL,editor[x],NULL);break;
        case 5: Grep(NULL,editor[x],NULL);break;
      }
    }
  }
EP;
}

void bookmark_cb(Widget w,int item,void *cbs)
{
  int x;
  
SP("bookmark_cb");
  for (x=0;x<editors;x++)
  {
    if (editor[x]->mb==XtParent(XtParent(XtParent(w))))
    {
      switch (item)
      {
        case 0: AddBookmark(editor[x]->filename);break;
        case 1: ShowBookmarkDialog();break;
      }
    }
  }
EP;
}

void tools_cb(Widget w,int item,void *cbs)
{
  int x;
  
SP("tools_cb");
  for (x=0;x<editors;x++)
  {
    if (editor[x]->mb==XtParent(XtParent(XtParent(w))))
    {
      switch (item)
      {
        case 0: Compile(NULL,editor[x],NULL);break;
        case 1: Make(NULL,editor[x],NULL);break;
        case 2: Run(NULL,editor[x],NULL);break;
        case 3: Grep(NULL,editor[x],NULL);break;
      }
    }
  }
EP;
}

void view_cb(Widget w,int item,void *cbs)
{
  int x;
  
SP("view_cb");
  for (x=0;x<editors;x++)
  {
    if (editor[x]->mb==XtParent(XtParent(XtParent(w))))
    {
      switch (item)
      {
        case 0: ShowEditorDialog();break;
        case 1: CreateOutputWindow(editor[x]);
        	/*XtManageChild(editor[x]->iod);*/
        	XtPopup(editor[x]->iod,XtGrabNone);
        	XMapRaised(XtDisplay(editor[x]->iod),XtWindow(editor[x]->iod));
        	break;
        case 2: ShowStats(editor[x]);break;
      }
    }
  }
EP;
}

void help_cb(Widget w,int item,void *cbs)
{
  int x;
  
SP("help_cb");
  for (x=0;x<editors;x++)
  {
    if (editor[x]->mb==XtParent(XtParent(XtParent(w))))
    {
      switch (item)
      {
        case 0: Help(NULL,"Contents",NULL);break;
        case 1: LatestVersion();break;
        case 2: ShowAboutDialog(editor[x]);break;
      }
    }
  }
EP;
}

