#include <Xm/Xm.h>
#include <Xm/FileSB.h>
#include <Xm/Text.h>
#include <Xm/TextStrSoP.h>
#include <Xm/MessageB.h>
#include "jex.h"

extern Widget top;

void CheckSaveAsOK(Widget w,Editor *e,Widget fw);

void SetTitle(Editor *e,char *str)
{
  char title[255],directory[255],file[255];

SP("SetTitle");
  if (str && *str)
  {
    sprintf(title,"jex: %s",str);
    SplitPath(str,directory,file);
    XtVaSetValues(e->shell,XmNiconName,file,NULL);
  }
  else
  {
    db_strcpy(title,"jex");
    XtVaSetValues(e->shell,XmNiconName,"jex",NULL);
  }
  XtVaSetValues(e->shell,XmNtitle,title,NULL);
  UpdateEditorDialog();
EP;
}

void SaveOK(Editor *e)
{
  int stat;
  char *str;

SP("SaveOK");
  if (e->read_only)
  {
    EP;
    return;
  }
  XtVaGetValues(e->text,XmNvalue,&str,NULL);
  stat=savefile(e,e->filename,str);
  XtFree(str);
  if (!stat)
    SaveError(e);
  else
  {
    e->saved=1;
    e->changes=0;
/*    XtUnmanageChild(e->save);*/
    SetSave(e,False);
    if (e->func2!=NULL)
      Function((void(*)(void))e->func2,e);
  }
EP;
}

void SaveAsOK(Widget w,Editor *e,Widget fw)
{
  char *file;
  int x;

SP("SaveAsOK");
  if (e->read_only)
  {
    EP;
    return;
  }
  XtVaGetValues(fw,XmNvalue,&file,NULL);
  db_strcpy(e->filename,file);
  GetFullFileName(e->filename);
  SetTitle(e,e->filename);
  SaveOK(e);
  if (strcmp(e->filename,file))
  {
    if (e->oldsource)
    {
printf("1\n");
       DetachEditor(e,file);
    }
    else
    {
printf("2\n");
      for (x=0;x<editors;x++)
      {
        if (editor[x]!=e && db_strcmp(editor[x]->filename,file)==0)
        {
printf("3\n");
          XmTextSetSource(e->tmpsource,XmTextGetSource(e->text),0,0);
          XmTextSetSource(e->text,XmTextGetSource(editor[x]->text),0,0);
          e->oldsource=1;
          editor[x]->oldsource=1;
          break;
        }
      }
    }
  }
  XtFree(file);
EP;
}

void NoOverwrite(Widget w,Editor *e,void *cbs)
{
SP("NoOverwrite");
  CreateFileSelectionDialog(e,"Save As",(void*)CheckSaveAsOK,e->func2);
EP;
}  

void CancelAskToOverwrite(Widget w,Editor *e,void *cbs)
{
SP("CancelAskToOverwrite");
  XtUnmanageChild(e->ato);
  SetCurrentWidget(e->text);
EP;
}

void AskToOverwriteOK(Widget w,Editor *e,void *cbs)
{
SP("AskToOverwriteOK");
  SaveAsOK(w,e,e->f);
  SetCurrentWidget(e->text);
EP;
}

void CheckSaveAsOK(Widget w,Editor *e,Widget fw)
{
  char *file;
  struct stat st;

SP("CheckSaveAsOK");
  if (e->read_only)
  {
    EP;
    return;
  }
  XtVaGetValues(fw,XmNvalue,&file,NULL);
  if (db_stat(file,&st)==-1)
    SaveAsOK(w,e,fw);
  else
  {
    if (e->ato==NULL)
    {
      e->ato=XmCreateQuestionDialog(e->shell,"AskToOverwrite",NULL,0);
      e->f=fw;
      XtAddCallback(e->ato,XmNokCallback,(XtCallbackProc)AskToOverwriteOK,e);
      XtAddCallback(e->ato,XmNcancelCallback,(XtCallbackProc)NoOverwrite,e);
      XtAddCallback(e->ato,XmNhelpCallback,(XtCallbackProc)CancelAskToOverwrite,e);
    }
    else
    {
      XtRemoveAllCallbacks(e->ato,XmNokCallback);
      XtRemoveAllCallbacks(e->ato,XmNcancelCallback);
      XtRemoveAllCallbacks(e->ato,XmNhelpCallback);
      e->f=fw;
      XtAddCallback(e->ato,XmNokCallback,(XtCallbackProc)AskToOverwriteOK,e);
      XtAddCallback(e->ato,XmNcancelCallback,(XtCallbackProc)NoOverwrite,e);
      XtAddCallback(e->ato,XmNhelpCallback,(XtCallbackProc)CancelAskToOverwrite,e);
    }
    XtManageChild(e->ato);
  }      
}

void SaveAs(Editor *e)
{
SP("SaveAs");
  if (e->read_only)
  {
    EP;
    return;
  }
  CreateFileSelectionDialog(e,"Save As",(void*)CheckSaveAsOK,e->func2);
EP;
}    

void Save(Widget w,Editor *e,void *cbs)
{
SP("Save");
  if (e->read_only)
  {
    EP;
    return;
  }
  if (w)
    e->func2=NULL;
  else
    e->func2=cbs;
  if (e->filename[0])
    SaveOK(e);
  else
    SaveAs(e);
EP;
}

void ValueChanged(Widget w,Editor *e,void *cbs)
{
SP("ValueChanged");
/*  XtManageChild(e->save);*/
  SetSave(e,True);
  e->saved=0;
EP;
}

void New(Editor *e)
{
SP("New");
  UnlinkFile(e);
  DetachEditor(e,NULL);
  XtVaSetValues(e->text,XmNvalue,"",NULL);
  e->saved=1;
  SetTitle(e,"");
  e->filename[0]=0;
/*  XtUnmanageChild(e->save);*/
  SetSave(e,False);
  NoUndo(e);
EP;
}

void LoadOK(Widget w,Editor *e,Widget fw)
{
  char *file;

SP("LoadOK");
  XtVaGetValues(fw,XmNvalue,&file,NULL);
  if (loadfile(e,file,0,1))
    LoadError(e);
  else
  {
 /*   db_strcpy(e->filename,file);*/
    XtFree(file);
/*    SetTitle(e,e->filename);*/
  }
EP;
}

void Load(Editor *e)
{
SP("Load");
  CreateFileSelectionDialog(e,"Load",(void*)LoadOK,NULL);
EP;
}

void Revert(Editor *e)
{
  char tmpstr[255];
  int result;
  FILE *f;

SP("Revert");
  if (e->read_only)
  {
    EP;
    return;
  }
  if (e->filename[0])
  {
    if (e->saved)
    {
      sprintf(tmpstr,"%s~",e->filename);
      if ((f=fopen(tmpstr,"r"))!=NULL)
      {
        fclose(f);
        CopyFile(tmpstr,e->filename);
        result=loadfile(e,tmpstr,0,0);
        CopyFile(e->filename,tmpstr);
      }
      else
      {
        EP;
        return;
      }
    }
    else
      result=loadfile(e,e->filename,0,0);
    if (result!=0)
      LoadError(e);
    else
      SetTitle(e,e->filename);
  }
EP;
}

void PrintOK(Editor *e)
{
SP("PrintOK");
  printfile(e,e->filename);
EP;
}

void Print(Editor *e)
{
SP("Print");
  if (!e->saved)
  {
    e->f=(void*)PrintOK;
    Save(NULL,(void*)e,NULL);
  }
  else
    PrintOK(e);
EP;
}

void InsertOK(Widget w,Editor *e,Widget fw)
{
  char *file;

SP("InsertOK");
  if (e->read_only)
  {
    EP;
    return;
  }
  XtVaGetValues(fw,XmNvalue,&file,NULL);
  if (loadfile(e,file,1,0))
    LoadError(e);
  XtFree(file);
EP;
}

void Insert(Editor *e)
{
SP("Insert");
  if (e->read_only)
  {
    EP;
    return;
  }
  CreateFileSelectionDialog(e,"Insert",(void*)InsertOK,NULL);
EP;
}

