#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <unistd.h>
#include <ctype.h>
#include "match.h"
#include "jex.h"
#include "list.h"

int subdirs=0,case_sensitive=0,do_replace=0;
List f_list=NULL;

void strupr(char *str)
{
SP("strupr");
  while (str && *str)
  {
    *str=toupper(*str);
    str++;
  }
EP;
}

void ReplaceString(char *str,char *srch,char *repl)
{
  int x;
  char tmpstr[255],tmppat[255];
  
  SP("ReplaceString");
  db_strcpy(tmpstr,str);
  db_strcpy(tmppat,srch);
  if (!case_sensitive)
  {
    strupr(tmpstr);
    strupr(tmppat);
  }
  for (x=0;x<db_strlen(tmpstr);x++)
  {
    if ((x>db_strlen(tmpstr)-db_strlen(srch)) || ((db_strlen(tmpstr)+db_strlen(repl)-db_strlen(tmppat))>=255))
    {
      EP;
      return;
    }
    if (db_memcmp(&tmpstr[x],tmppat,db_strlen(tmppat))==0)
    {
      if (x==0 || (x>0 && !isalpha(tmpstr[x-1]) && tmpstr[x-1]!='_'))
      {
        db_memmove(&str[x],&str[x+db_strlen(srch)],db_strlen(str)-x-db_strlen(srch)+1);
        db_memmove(&str[x+db_strlen(repl)],&str[x],db_strlen(str)-x+1);
        db_memcpy(&str[x],repl,db_strlen(repl));
        db_memmove(&tmpstr[x],&tmpstr[x+db_strlen(tmppat)],db_strlen(tmpstr)-x-db_strlen(tmppat)+1);
        db_memmove(&tmpstr[x+db_strlen(repl)],&tmpstr[x],db_strlen(tmpstr)-x+1);
        db_memcpy(&tmpstr[x],repl,db_strlen(repl));
        x+=db_strlen(repl);
      }
    }
  }
  EP;
}

void DoGrep(char *patrn,char *replace)
{
  FILE *f,*f3=NULL;
  int line=0,x,nl=1;
  char str[255],str2[255],nw[255];
  char path[255],direc[255],pattern[255],file[255],pat[255];
  DIR *dp;
  struct dirent *dir;
  struct stat sbuf;
 
SP("DoGrep");
  sprintf(pat,"*%s*",patrn);
  if (!case_sensitive)
    strupr(pat);
  while (GetFirstElement(f_list,path))
  {
    DeleteFirstElement(f_list);
    SplitPath(path,direc,pattern);
    if ((dp=db_opendir(direc))==NULL)
    {
      fprintf(stderr,"Can't open directory %s\n",path);
      continue;
    }
    while ((dir=db_readdir(dp))!=NULL)
    {
      if (dir->d_ino==0)
        continue;
      if (db_strcmp(direc,".")==0 || db_strcmp(direc,"./")==0)
        sprintf(file,dir->d_name);
      else
      {
        if (direc[db_strlen(direc)-1]!='/')
          sprintf(file,"%s/%s",direc,dir->d_name);
        else
          sprintf(file,"%s%s",direc,dir->d_name);
      }
      if (db_stat(file,&sbuf)<0)
      {
        if (db_lstat(file,&sbuf)<0)
        {
          continue;
        }
      }
      if ((sbuf.st_mode&S_IFMT)==S_IFDIR)
      {
        if (subdirs && db_strcmp(dir->d_name,".")!=0 && db_strcmp(dir->d_name,"..")!=0)
        {
          sprintf(path,"%s/%s",file,pattern);
          AddFirstElement(f_list,path);
        }
        continue;
      }
      if (match(pattern,dir->d_name))
      {
        if ((f=db_fopen(file,"r"))==NULL)
        {
          printf("Can't open file %s\n",file);
          continue;
        }
        if (do_replace)
        {
          sprintf(nw,"%s.tmp",file);
          if ((f3=db_fopen(nw,"w+"))==NULL)
          {
            printf("Cannot open file %s\n",nw);
            db_fclose(f);
            return;
          }
        }
        line=0;
        while (db_fgets(str,254,f)!=NULL)
        {
          if (str[db_strlen(str)-1]=='\n')
          {
            line++;
            str[db_strlen(str)-1]='\0';
            nl=1;
          }
          else
            nl=0;
          db_strcpy(str2,str);
          if (do_replace)
          {
            ReplaceString(str2,patrn,replace);
            if (nl)
              db_fprintf(f3,"%s\n",str2);
            else
              db_fprintf(f3,"%s",str2);
          }
          if (!case_sensitive)
            strupr(str);
          if (match(pat,str))
          {
            for (x=0;x<db_strlen(str2);x++)
            {
              if (str2[x]=='\t')
                str2[x]=' ';
            }
            printf("%s:%d: %s\n",file,line,str2);
          }
        }
        db_fclose(f);
        if (do_replace)
          db_fclose(f3);
        db_rename(nw,file);
      }
    }
    db_closedir(dp);
  }
EP;
}

