#include <Xm/Xm.h>
#include <Xm/MessageB.h>
#include <Xm/Text.h>
#include <Xm/List.h>
#include <Xm/DialogS.h>
#include <Xm/Protocols.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "list.h"
#include "jex.h"
#include "help.h"
#include "helpstack.h"

extern Widget top;
List help_topics=NULL;
extern Pixmap pixmap;
Widget help_dialog=NULL,textw,tlist=NULL,tshell=NULL,ad=NULL;
HStack *hst=NULL;
char current_topic[40],helpfile[255];
List l=NULL;
extern XtAppContext app;

void SetZeroPos(Widget w,void *id)
{
SP("SetZeroPos");
  XmTextSetInsertionPosition(w,0);
  XmTextShowPosition(w,0);
EP;
}  

/* Checks if the user has clicked on a link, if so, the current link is pushed
   on the stack and the next topic is displayed.*/
void CheckLink(Widget w,List data,XmTextVerifyCallbackStruct *cbs)
{
  int pos=cbs->newInsert;
  HelpText ht;
  HStackElem el;

SP("CheckLink");
  if (GetFirstElement(data,&ht))
  {
    do
    {
      if (pos>=ht.start && pos<=ht.end)
      {
	XtRemoveCallback(w,XmNmotionVerifyCallback,(XtCallbackProc)CheckLink,data);
        db_strncpy(el.data,current_topic,40);
        Push(hst,el);
        XtSetSensitive(XmMessageBoxGetChild(help_dialog,XmDIALOG_CANCEL_BUTTON),True);
	DisplayTopic(w,ht.link,helpfile,data);
	XtAppAddTimeOut(app,0,(XtTimerCallbackProc)SetZeroPos,w);
EP;
	return;
      }
    } while (GetNextElement(data,&ht));
  }
EP;
}

/* Display a new topic in the help window. The text is loaded from the file. */
void DisplayTopic(Widget w,char *topic,char *file,List l)
{
  FILE *f;
  HelpTopic htop;
  HelpText ht,ht2;
  char *str;
  XmTextPosition position=0;
  int found=0,first;

SP("DisplayTopic");
/*  XmTextSetString(w,""); */
  if ((f=db_fopen(file,"r"))==NULL)
  {
/*    XmTextSetString(w,"Cannot open help file!");*/
    HelpError("Cannot open help file!");
    XtAddCallback(w,XmNmotionVerifyCallback,(XtCallbackProc)CheckLink,l);
EP;
    return;
  }
  if (GetFirstElement(help_topics,&htop))
  {
    do
    {
      if (db_strcmp(topic,htop.topic)==0)
      {
	found=1;
        break;
      }
    } while (GetNextElement(help_topics,&htop));
    if (!found)
    {
/*      XmTextSetString(w,"Topic not found!");*/
      HelpError("Topic not found!");
      XtAddCallback(w,XmNmotionVerifyCallback,(XtCallbackProc)CheckLink,l);
      db_fclose(f);
EP;
      return;
    }
  }
  db_strncpy(current_topic,topic,40);
  ClearList(l);
  XmTextSetString(w,""); 
  if (GetFirstElement(htop.list,&ht)) 
  {				      
    first=ht.start;
    do
    {
      db_fseek(f,ht.start,0);
      str=(char *)db_malloc(ht.end-ht.start+1);          
      db_fread(str,ht.end-ht.start,1,f);
      str[ht.end-ht.start]=0;
      XmTextReplace(w,position,position+ht.end-ht.start,str);
      ht2.start=position;
      position+=ht.end-ht.start;
      ht2.end=position;
      db_strcpy(ht2.link,ht.link);
      db_free(str);
      if (ht.type==LINK_TEXT)
      {
	XmTextSetHighlight(w,ht2.start,ht2.end,XmHIGHLIGHT_SECONDARY_SELECTED);
	AddElement(l,&ht2);
      }
/*      XmTextSetInsertionPosition(w,0);
      XmTextShowPosition(w,0);*/
    } while (GetNextElement(htop.list,&ht));
  }
  XmTextSetInsertionPosition(w,0);
  XmTextShowPosition(w,0);
  XtAddCallback(w,XmNmotionVerifyCallback,(XtCallbackProc)CheckLink,l);
  db_fclose(f);
EP;
}

void help_ok(Widget w,List data,void *cbs)
{
SP("help_ok");
/*  DisposeList(data);
  l=NULL;
  XtPopdown(XtParent(help_dialog));
  help_dialog=NULL; */
  XtUnmanageChild(help_dialog);
EP;
}

void help_cancel(Widget w,List data,void *cbs)
{
  HStackElem el;

SP("help_cancel");
  Pop(hst,&el);
  XtRemoveCallback(textw,XmNmotionVerifyCallback,(XtCallbackProc)CheckLink,data);
  if (StackSize(hst)==0)
    XtSetSensitive(XmMessageBoxGetChild(help_dialog,XmDIALOG_CANCEL_BUTTON),False);
  DisplayTopic(textw,el.data,helpfile,data);
EP;
}

void Help(Widget widget,char *c,void *d)
{
  Arg arg[7];
  XmTextScanType s_array[5];
/*  Atom wm_delete;*/

SP("Help");
  if (help_dialog==NULL)
  {
    hst=CreateHStack();
    if ((help_topics=CompileHelp())==NULL)
    {
      HelpError("Can't find help file!");
EP;
      return;
    }
    l=CreateList(sizeof(HelpText));
    XtSetArg(arg[1],XmNdeleteResponse,XmDO_NOTHING);
    XtSetArg(arg[0],XmNautoUnmanage,False);
    help_dialog=XmCreateMessageDialog(top,"Help",arg,1);
    XtAddCallback(help_dialog,XmNokCallback,help_ok,l);
    XtAddCallback(help_dialog,XmNcancelCallback,help_cancel,l);
    XtAddCallback(help_dialog,XmNhelpCallback,Index,NULL);
    XtSetSensitive(XmMessageBoxGetChild(help_dialog,XmDIALOG_CANCEL_BUTTON),False);
    if (help_topics==0)
      XtSetSensitive(XmMessageBoxGetChild(help_dialog,XmDIALOG_HELP_BUTTON),False);
    s_array[0]=XmSELECT_POSITION;
    s_array[1]=XmSELECT_POSITION;
    s_array[2]=XmSELECT_POSITION;
    s_array[3]=XmSELECT_POSITION;
    s_array[4]=XmSELECT_POSITION;
    XtSetArg(arg[0],XmNeditable,False);
    XtSetArg(arg[1],XmNeditMode,XmMULTI_LINE_EDIT);
    XtSetArg(arg[2],XmNselectionArray,s_array);
    XtSetArg(arg[3],XmNselectionArrayCount,5);
    XtSetArg(arg[4],XmNcursorPositionVisible,False);
    XtSetArg(arg[5],XmNwordWrap,True);
    XtSetArg(arg[6],XmNscrollHorizontal,False);
    textw=XmCreateScrolledText(help_dialog,"help_text",arg,7);
/*    wm_delete=XmInternAtom(XtDisplay(help_dialog),"WM_DELETE_WINDOW",False);
    XmAddWMProtocolCallback(XtParent(help_dialog),wm_delete,help_ok,NULL);*/
    XtManageChild(textw);
    XtManageChild(help_dialog);
  }
  else
  {
    HStackElem el;
   
    db_strncpy(el.data,current_topic,40);
    Push(hst,el);
    XtSetSensitive(XmMessageBoxGetChild(help_dialog,XmDIALOG_CANCEL_BUTTON),True);
    if (help_topics==0)
      XtSetSensitive(XmMessageBoxGetChild(help_dialog,XmDIALOG_HELP_BUTTON),False);
    XtRemoveCallback(textw,XmNmotionVerifyCallback,(XtCallbackProc)CheckLink,l);
    XtManageChild(help_dialog);
  }
  DisplayTopic(textw,c,helpfile,l);  
EP;
}

/* Callback for the index, when the user selects a topic. */
void list_select(Widget w,void *data,XmListCallbackStruct *cbs)
{
  HelpTopic htop;

SP("list_select");
  GetNthElement(help_topics,cbs->item_position-1,&htop);
  Help(NULL,htop.topic,NULL);  
  XtPopdown(tshell);
EP;
}

void index_close(Widget w,void *d,void *cbs)
{
SP("index_close");
  XtPopdown(tshell);
EP;
}

int SortProc(const void *n1,const void *n2)
{
  int x;

SP("SortProc");
  x=db_strcmp(((HelpTopic*)n1)->topic_text,((HelpTopic*)n2)->topic_text);
  if (x<0)
  {
    EP;
    return -1;
  }
  else if (x>0)
  {
    EP;
    return 1;
  }
EP;
  return 0;
}

void Index(Widget w,void *data,void *cbs)
{
  XmStringTable tops;
  int x=0,n;
  HelpTopic htop;
  Atom wm_delete;

SP("Index");
  if (tshell==NULL)
  {
    n=NumberElements(help_topics);
    if (n==0)
    {
      EP;
      return;
    }
    tops=(XmStringTable)XtMalloc(n*sizeof(XmString));
    SortList(help_topics,SortProc);	    
    if (GetFirstElement(help_topics,&htop)) 
    {					    
      do
      {
        tops[x++]=XmStringCreateLocalized(htop.topic_text);
      } while (GetNextElement(help_topics,&htop));
    }

    tshell=XtVaCreatePopupShell("Topics",xmDialogShellWidgetClass,top,
		XmNdeleteResponse,XmDO_NOTHING,
	 	XmNallowShellResize,True,	
		NULL);

    tlist=XmCreateScrolledList(tshell,"help_topics",NULL,0);
    XtVaSetValues(tlist,XmNitems,tops,
		XmNitemCount,n,
		XmNdeleteResponse,XmDO_NOTHING,	
		XmNselectionPolicy,XmBROWSE_SELECT,
		NULL);

    XtAddCallback(tlist,XmNdefaultActionCallback,(XtCallbackProc)list_select,NULL);
    wm_delete=XmInternAtom(XtDisplay(tshell),"WM_DELETE_WINDOW",False);
    XmAddWMProtocolCallback(tshell,wm_delete,index_close,NULL);
    XtManageChild(tlist);
    XtManageChild(tshell);
  }
  else
    XtPopup(tshell,XtGrabNone);
EP;
}

int FindHelpFile(char *helpfile,char *file)
{
  char *env,*pos,*orig;
  FILE *f;

SP("FindHelp");
  if (!getenv("PATH"))
  {
    EP;
    return 0;
  }
  orig=env=db_strdup(getenv("PATH"));
  pos=db_strchr(env,':');
  while (pos)
  {
    *pos=0;
    sprintf(file,"%s/%s",env,helpfile);
    if ((f=fopen(file,"r"))!=NULL)
    {
      fclose(f);
      db_free(orig);
      EP;
      return 1;
    }
    env=pos+1;
    pos=db_strchr(env,':');
  }
  sprintf(file,"%s/%s",env,helpfile);
  if ((f=fopen(file,"r"))!=NULL)
  {
    fclose(f);
    db_free(orig);
    EP;
    return 1;
  }
  db_free(orig);
EP;
  return 0;
}

List CompileHelp(void)
{
  FILE *f;
  char ch,str[100];
  int start,end,eof=0;
  HelpText ht;
  HelpTopic htop;
  List l;

SP("CompileHelp");
  if (!FindHelpFile("jex.hlp",helpfile))
  {
    EP;
    return NULL;
  }
  if ((f=db_fopen(helpfile,"r"))==NULL)
  {
    EP;
    return NULL;
  }
  l=CreateList(sizeof(HelpTopic));
  while (!db_feof(f))
  {
    start=db_ftell(f);
    fscanf(f,"%s",str);
    if (db_strcmp(str,".topic")==0) 
    {
      htop.list=CreateList(sizeof(HelpText));
      fscanf(f,"%s",htop.topic);
      ht.start=start=db_ftell(f)+1;
      while ('\n'!=db_fgetc(f));
      while ((ch=db_fgetc(f))==' ' || ch=='\t' || ch=='\n');
      db_ungetc(ch,f);
      db_fgets(htop.topic_text,100,f);
      htop.topic_text[strlen(htop.topic_text)-1]=0;
      AddElement(l,&htop); 
      for (;;)
      {
	ch=db_fgetc(f);
	if (db_feof(f))
 	{
	  end=db_ftell(f);
	  eof=1;
	  break;
	}
	if (ch=='.')
	{
	  end=db_ftell(f)-1;
	  fscanf(f,"%s",str);
	  db_fseek(f,end,0);
	  if (db_strcmp(str,"topic")==0)
	    break;
	  else
	    db_fseek(f,end+1,0);
	}
	else if (ch=='{') 
	{
	  end=db_ftell(f)-1;
	  ht.end=end;
	  ht.type=NORMAL_TEXT;
	  AddElement(htop.list,&ht); 
	  ht.start=end+1;
	  ht.type=LINK_TEXT;
	  do
	  {
	    ch=db_fgetc(f);
	  } while (ch!=':' && ch!='}');
	  ht.end=db_ftell(f)-1;
	  if (ch=='}')
	    db_fseek(f,end+1,0);
	  end=0;
	  do  
	  {
	    ch=db_fgetc(f);
	    if (ch!=' ' && ch!='}')
	      ht.link[end++]=ch;
	  } while (ch!='}');
	  ht.link[end]=0;
	  AddElement(htop.list,&ht);
	  ht.start=start=db_ftell(f);
	}
	else if (ch=='\\') 
	{
	  ht.end=db_ftell(f)-1;
          ht.type=NORMAL_TEXT;
          AddElement(htop.list,&ht);
          db_fgetc(f);
          ht.start=db_ftell(f)-1;
        }
      }
      ht.type=NORMAL_TEXT;
      ht.end=end;
      AddElement(htop.list,&ht);
      if (eof)
	break;
    }
    else
    {
      db_fclose(f);
      EP;
      return NULL;
    }
  }
  db_fclose(f);
EP;
  return l;
}

