#ifndef _HELP_H_
#define _HELP_H_

#include "list.h"
#include <Xm/Xm.h>

typedef enum { NORMAL_TEXT, LINK_TEXT } TextType;
typedef struct {
		 TextType type;
		 int start,end;
	 	 char link[40];
	       } HelpText;

typedef struct {
		 char topic[40];
		 char topic_text[80];
	 	 List list;
	       } HelpTopic;

void Help(Widget widget,char *c,void *d);
/* Displays the help dialog of the topic c. */

List CompileHelp(void);
/* Compiles the help file. */

void Index(Widget w,void *data,void *cbs);
/* Displays an index of help topics. */

void DisplayTopic(Widget w,char *topic,char *file,List l);
/* Displays a new topic from the help file in the help dialog.
   l contains the hyperlinks list. */

void HelpError(char *msg);

#endif
