#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "helpstack.h"
#include "jex.h"

HStack *CreateHStack(void)
{
  HStack *hst;
  
SP("CreateHStack");
  if ((hst=(HStack*)db_malloc(sizeof(HStack)))==NULL)
  {
    EP;
    return NULL;
  }
  hst->nelems=0;
  hst->last=NULL;
EP;
  return hst;
}

void DestroyHStack(HStack *hst)
{
  HStackElement *ptr;

SP("DestroyHStack");
  if (!hst)
  {
    EP;
    return;
  }
  ptr=hst->last;
  while (hst->last && ptr->prev)
  {
    hst->last=ptr->prev;
    db_free(ptr);
    ptr=hst->last;
  }
  if (hst->last)
    db_free(hst->last);
  db_free(hst);
EP;
}

void StackClear(HStack *hst)
{
  HStackElement *ptr;

SP("StackClear");
  if (!hst)
  {
    EP;
    return;
  }
  ptr=hst->last;
  while (hst->last && ptr->prev)
  {
    hst->last=ptr->prev;
    db_free(ptr);
    ptr=hst->last;
  }
  if (hst->last)
    db_free(hst->last);
  hst->last=NULL;
  hst->nelems=0;
EP;
}

int Push(HStack *hst,HStackElem data)
{
  HStackElement *ptr;

SP("Push");
  if (!hst)
  {
    EP;
    return 0;
  }
  if ((ptr=(HStackElement *)db_malloc(sizeof(HStackElement)))==NULL)
  {
    EP;
    return -1;
  }
  db_memcpy(&ptr->s,&data,sizeof(HStackElem));
  ptr->prev=hst->last;
  hst->last=ptr;
  hst->nelems++;
EP;
  return hst->nelems-1;
}

int Pop(HStack *hst,HStackElem *data)
{
  HStackElement *ptr;

SP("Pop");
  if (!hst || !data)
  {
    EP;
    return 0;
  }
  if (hst->nelems==0)
  {
    EP;
    return 0;
  }
  db_memcpy(data,&hst->last->s,sizeof(HStackElem));
  ptr=hst->last;
  hst->last=hst->last->prev;
  db_free(ptr);
  hst->nelems--;
EP;
  return hst->nelems;
}

int StackSize(HStack *hst)
{
SP("StackSize");
  if (!hst)
  {
    EP;
    return 0;
  }
EP;
  return hst->nelems;
}
