#include <Xm/PushB.h>
#include <Xm/Xm.h>
#include <Xm/RowColumn.h>
#include <Xm/PushBG.h>
#include "jex.h"

int fl_size=0;
char fl_files[FILELIST][255];

void LoadOldFile(Editor *e)
{
SP("LoadOldFile");
  if (loadfile(e,e->choice,0,1))
    LoadError(e);
EP;
}

void OpenOldFile(Widget w,Editor *e,void *cbs)
{
  int x;
  
SP("OpenOldFile");
  for (x=0;x<fl_size;x++)
  {
    if (e->filelist[x]==w)
    {
      if (e->new_window)
      {
        CreateNewEditor();
        if (loadfile(editor[editors-1],fl_files[x],0,1))
          LoadError(editor[editors-1]);
      }
      else
      {
        db_strcpy(e->choice,fl_files[x]);
        if (e->saved)
          LoadOldFile(e);
        else
          AskToSave(e,(void*)LoadOldFile);
      }
      break;
    }
  }
EP;
}

void UpdateFileList(char *file)
{
  int x,end,exists=0,e;
  XmString xstr;

SP("UpdateFileList");
  end=fl_size;
  if (file && file[0])
  {
    for (x=0;x<fl_size;x++)
    {
      if (db_strcmp(fl_files[x],file)==0)
      {
        end=x+1;
        exists=1;
        break;
      }
    }
    if (fl_size<FILELIST && !exists)
    {
      for (x=0;x<editors;x++)
      {
        editor[x]->filelist[fl_size]=XtVaCreateManagedWidget("filebutton",
       	  xmPushButtonGadgetClass,editor[x]->filemenu,NULL);
        XtAddCallback(editor[x]->filelist[fl_size],XmNactivateCallback,(XtCallbackProc)OpenOldFile,(void*)editor[x]);
      }
      fl_size++;
      end=fl_size;
    }
    for (x=end-2;x>=0;x--)
      db_strcpy(fl_files[x+1],fl_files[x]);
    db_strcpy(fl_files[0],file);
  }
  for (x=0;x<end;x++)
  {
    xstr=XmStringCreateLocalized(fl_files[x]);
    for (e=0;e<editors;e++)
    {
      XtVaSetValues(editor[e]->filelist[x],XmNlabelString,xstr,NULL);
    }
    XmStringFree(xstr);
  }
EP;
}

void Reload(Editor *e)
{
SP("Reload");
  if (e->filename[0])
  {
    db_strcpy(e->choice,e->filename);
    if (e->saved)
      LoadOldFile(e);
    else
      AskToSave(e,(void*)LoadOldFile);
  }
EP;
}

