#include <stdio.h>
#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/RowColumn.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>
#include <Xm/PushBG.h>
#include <Xm/PushB.h>
#include <Xm/DrawnB.h>
#include <Xm/ArrowBG.h>
#include <Xm/LabelG.h>
#include <Xm/ArrowB.h>
#include <Xm/Protocols.h>
#include <X11/Shell.h>
#include <sys/types.h>
#include <sys/time.h>
#include "fallbacks.h"
#include "jex.h"
#include "xpm.h"
#include "jex.xpm"
#include "lov.xbm"
#include "new.xpm"
#include "open.xpm"
#include "save.xpm"
#include "save2.xpm"
#include "clear.xpm"
#include "clone.xpm"
#include "compile.xpm"
#include "copy.xpm"
#include "cut.xpm"
#include "grep.xpm"
#include "left.xpm"
#include "make.xpm"
#include "newwind.xpm"
#include "paste.xpm"
#include "redo.xpm"
#include "right.xpm"
#include "undo.xpm"
#include "undo2.xpm"
#include "redo2.xpm"
#include "compile2.xpm"
#include "make2.xpm"
#include "grep2.xpm"
#include "up.xpm"
#include "down.xpm"
#include "setmarker.xpm"
#include "gotomarker.xpm"
#include "gotomarker2.xpm"
#include "caps.xpm"
#include "lows.xpm"
#include "down2.xpm"
#include "run.xpm"
#include "run2.xpm"
#include "gotoline.xpm"

#ifndef MAX
#define MAX(x,y) (((x)>(y))?(x):(y))
#endif

Widget top,combo1,combo2,combo3,combo4,combo5,combo6;
XtAppContext app;
int editors=0;
Editor *editor[MAXEDITORS];
Pixmap pixmap,lov,_new,_open,_save,_save2,_clear,_clone,_compile,_copy,_cut;
Pixmap _grep,_left,_make,_newwind,_paste,_redo,_right,_undo,_undo2,_redo2;
Pixmap _compile2,_make2,_grep2,_up,_down,_lows,_caps,_setmarker,_gotomarker;
Pixmap _gotomarker2,_down2,_run,_run2,_gotoline;
extern int fl_size,find_size,repl_size;
OwnRes ownres;
XtResource resources[]={
{"history_in_home_dir","History_In_Home_Dir",XtRBoolean,sizeof(Boolean),XtOffsetOf(OwnRes,histhome),XtRString,"False"},
{"settings_in_home_dir","Settings_In_Home_Dir",XtRBoolean,sizeof(Boolean),XtOffsetOf(OwnRes,setthome),XtRString,"False"}
};

void WriteTime(Editor *e,XtIntervalId id)
{
  char timebuffer[100];
  time_t t;
  XmString xstr;
  struct tm *lt;
  
SP("WriteTime");
  time(&t);
  strftime(timebuffer, 100, "%d/%m/%Y %H:%M",
           localtime(&t));
  xstr=XmStringCreateLocalized(timebuffer);
  XtVaSetValues(e->clock,XmNlabelString,xstr,NULL);
  XmStringFree(xstr);
  lt=localtime(&t);
  if (lt->tm_sec>60 || lt->tm_sec<0)
    lt->tm_sec=59;
  e->tid2=XtAppAddTimeOut(app,MAX(0,(60-lt->tm_sec)*1000),(XtTimerCallbackProc)WriteTime,e);
EP;
}

void CreateEditor(Widget top)
{
  Widget mf,rc1,rc2,find,repl,aup,adown,replall;
  Widget w,_goto,lows,caps;
  Arg args[10];
  Atom atom;
  Editor *e;
  int x,n;
  
SP("CreateEditor");
  if (editors>=MAXEDITORS)
  {
    EP;
    return;
  }
    
  e=(Editor*)db_malloc(sizeof(Editor));
  editor[editors]=e;

  e->undolist=CreateList(sizeof(Undo_T));
  e->redolist=CreateList(sizeof(Undo_T));
  mf=XtVaCreateManagedWidget("mainform",xmFormWidgetClass,top,NULL);

  e->mb=XmVaCreateSimpleMenuBar(mf,"menubar",
	XmVaCASCADEBUTTON,NULL,0,
	XmVaCASCADEBUTTON,NULL,0,
	XmVaCASCADEBUTTON,NULL,0,
	XmVaCASCADEBUTTON,NULL,0,
	XmVaCASCADEBUTTON,NULL,0,
	XmVaCASCADEBUTTON,NULL,0,
	XmVaCASCADEBUTTON,NULL,0,
	XmVaCASCADEBUTTON,NULL,0,
	XmNrightAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_FORM,
	XmNtopAttachment,XmATTACH_FORM,
	NULL);

  e->filemenu=XmVaCreateSimplePulldownMenu(e->mb,"filemenu",0,file_cb,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaSEPARATOR,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaSEPARATOR,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaSEPARATOR,
	NULL);

  XmVaCreateSimplePulldownMenu(e->mb,"editmenu",1,edit_cb,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaSEPARATOR,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaSEPARATOR,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	NULL);

  XmVaCreateSimplePulldownMenu(e->mb,"optionmenu",2,option_cb,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaRADIOBUTTON,NULL,0,NULL,NULL,
	NULL);

  e->bookmarkmenu=XmVaCreateSimplePulldownMenu(e->mb,"bookmarkmenu",3,bookmark_cb,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaSEPARATOR,
	NULL);

  XmVaCreateSimplePulldownMenu(e->mb,"toolsmenu",4,tools_cb,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	NULL);

  XmVaCreateSimplePulldownMenu(e->mb,"viewmenu",5,view_cb,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	NULL);

  w=XmVaCreateSimplePulldownMenu(e->mb,"helpmenu",7,help_cb,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	XmVaSEPARATOR,
	XmVaPUSHBUTTON,NULL,0,NULL,NULL,
	NULL);

#ifndef LESSTIFF    
  if ((w=XtNameToWidget(e->mb,"button_7"))!=NULL)
    XtVaSetValues(e->mb,XmNmenuHelpWidget,w,NULL);
#endif

  XtManageChild(e->mb);

  rc1=XtVaCreateManagedWidget("toprc",xmFormWidgetClass,mf,
	XmNtopAttachment,XmATTACH_WIDGET,
	XmNtopWidget,e->mb,
	XmNleftAttachment,XmATTACH_FORM,
	XmNrightAttachment,XmATTACH_FORM,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNfractionBase,10,
	NULL);

  e->rowcol=XtVaCreateManagedWidget("1:1",xmLabelGadgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_NONE,
	XmNrightAttachment,XmATTACH_FORM,
	XmNbottomAttachment,XmATTACH_FORM,
	NULL);

  w=XtVaCreateManagedWidget("DBNew",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_FORM,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_new,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)DoNew,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,False,(XtEventHandler)SmallHelp,(void*)1);
  XtAddEventHandler(w,LeaveWindowMask,False,(XtEventHandler)RemoveSmallHelp,NULL);

  w=XtVaCreateManagedWidget("DBOpen",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_open,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)DoOpen,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)2);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  e->save=XtVaCreateManagedWidget("DBSave",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_save,
	XmNlabelInsensitivePixmap,_save2,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);
  XtAddCallback(e->save,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(e->save,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)3);
  XtAddEventHandler(e->save,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  w=XtVaCreateManagedWidget("DBNewWind",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,e->save,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_newwind,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	XmNleftOffset,10,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)DoNewWindow,NULL);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)4);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  w=XtVaCreateManagedWidget("DBClone",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_clone,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)DoClone,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)5);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  w=XtVaCreateManagedWidget("DBCut",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_cut,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	XmNleftOffset,10,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)CutText,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)6);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  w=XtVaCreateManagedWidget("DBCopy",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_copy,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)CopyText,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)7);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  w=XtVaCreateManagedWidget("DBPaste",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_paste,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)PasteText,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)8);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  w=XtVaCreateManagedWidget("DBClear",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_clear,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)ClearSelection,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)9);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  w=XtVaCreateManagedWidget("DBUndo",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_undo,
	XmNlabelInsensitivePixmap,_undo2,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	XmNleftOffset,10,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)UndoAction,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)10);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  e->undo=w;

  w=XtVaCreateManagedWidget("DBRedo",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_redo,
	XmNlabelInsensitivePixmap,_redo2,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RedoAction,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)11);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  e->redo=w;

  w=XtVaCreateManagedWidget("DBCompile",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_compile,
	XmNlabelInsensitivePixmap,_compile2,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	XmNleftOffset,10,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)Compile,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)14);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  e->compile=w;

  w=XtVaCreateManagedWidget("DBMake",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_make,
	XmNlabelInsensitivePixmap,_make2,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)Make,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)15);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  e->make=w;

  w=XtVaCreateManagedWidget("DBRun",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_run,
	XmNlabelInsensitivePixmap,_run2,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)Run,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)26);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  e->run=w;

  w=XtVaCreateManagedWidget("DBGrep",xmDrawnButtonWidgetClass,rc1,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_grep,
	XmNlabelInsensitivePixmap,_grep2,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)Grep,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)16);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  e->grep=w;

  e->clock=XtNameToWidget(e->mb,"button_6");	

  XtAddCallback(e->save,XmNactivateCallback,(XtCallbackProc)Save,e);
  SetSave(e,False);

  rc2=XtVaCreateManagedWidget("bottomform",xmFormWidgetClass,mf,
	XmNtopAttachment,XmATTACH_NONE,
	XmNleftAttachment,XmATTACH_FORM,
	XmNrightAttachment,XmATTACH_FORM,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNhorizontalSpacing,0,
	XmNfractionBase,20,
	NULL);

  repl=XtVaCreateManagedWidget("Replace",xmLabelGadgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,10,
	XmNleftAttachment,XmATTACH_FORM,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_FORM,
	XmNalignment,XmALIGNMENT_BEGINNING,
	NULL);

  find=XtVaCreateManagedWidget("Find",xmLabelGadgetClass,rc2,
	XmNtopAttachment,XmATTACH_FORM,
	XmNleftAttachment,XmATTACH_FORM,
	XmNrightAttachment,XmATTACH_OPPOSITE_WIDGET,
	XmNrightWidget,repl,
	XmNbottomAttachment,XmATTACH_POSITION,
	XmNbottomPosition,10,
	XmNalignment,XmALIGNMENT_BEGINNING,
	NULL);

  n=0;
  XtSetArg(args[n],XmNtopAttachment,XmATTACH_FORM);n++;	
  XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET);n++;	
  XtSetArg(args[n],XmNleftWidget,find);n++;	
  XtSetArg(args[n],XmNrightAttachment,XmATTACH_NONE);n++;	
  XtSetArg(args[n],XmNbottomAttachment,XmATTACH_POSITION);n++;	
  XtSetArg(args[n],XmNbottomPosition,10);n++;	
  e->findf=CreateComboBox(rc2,"findfield",args,n,10);
  InitializeComboBox(e->findf,editor[0]->findf);
  XtAddCallback(e->findf,XmNactivateCallback,(XtCallbackProc)FindDown,e);

  n=0;
  XtSetArg(args[n],XmNtopAttachment,XmATTACH_WIDGET);n++;
  XtSetArg(args[n],XmNtopWidget,XtParent(e->findf));n++;
  XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET);n++;
  XtSetArg(args[n],XmNleftWidget,repl);n++;
  XtSetArg(args[n],XmNrightAttachment,XmATTACH_NONE);n++;
  XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM);n++;
  e->replf=CreateComboBox(rc2,"replacefield",args,n,10);
  InitializeComboBox(e->replf,editor[0]->replf);
  XtAddCallback(e->replf,XmNactivateCallback,(XtCallbackProc)Replace,e);
  
  adown=XtVaCreateManagedWidget("DBDown",xmDrawnButtonWidgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,1,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,XtParent(e->findf),
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_down,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	XmNleftOffset,2,
	NULL);

  XtAddCallback(adown,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(adown,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)17);
  XtAddEventHandler(adown,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  XtAddCallback(adown,XmNactivateCallback,(XtCallbackProc)FindDown,e);

  aup=XtVaCreateManagedWidget("DBUp",xmDrawnButtonWidgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,1,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,adown,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_up,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(aup,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(aup,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)18);
  XtAddEventHandler(aup,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  XtAddCallback(aup,XmNactivateCallback,(XtCallbackProc)FindUp,e);

  adown=XtVaCreateManagedWidget("DBDown2",xmDrawnButtonWidgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,11,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,XtParent(e->replf),
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_down,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	XmNleftOffset,2,
	NULL);

  XtAddEventHandler(adown,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)19);
  XtAddEventHandler(adown,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  XtAddCallback(adown,XmNactivateCallback,(XtCallbackProc)Replace,e);
  XtAddCallback(adown,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);

  replall=XtVaCreateManagedWidget("DBDown3",xmDrawnButtonWidgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,11,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,adown,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_down2,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddEventHandler(replall,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)20);
  XtAddEventHandler(replall,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
  XtAddCallback(replall,XmNactivateCallback,(XtCallbackProc)ReplaceAll,e);
  XtAddCallback(replall,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);

  w=XtVaCreateManagedWidget("DBLeft",xmDrawnButtonWidgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,1,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,aup,
	XmNleftOffset,10,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_left,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	XmNleftOffset,10,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)ShiftLeft,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)12);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  w=XtVaCreateManagedWidget("DBRight",xmDrawnButtonWidgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,1,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_right,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)ShiftRight,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)13);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  caps=XtVaCreateManagedWidget("Caps",xmDrawnButtonWidgetClass,rc2,
  	XmNlabelType,XmPIXMAP,
  	XmNlabelPixmap,_caps,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,1,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNleftOffset,10,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);
  XtAddCallback(caps,XmNactivateCallback,(XtCallbackProc)CapsSelection,e);
  XtAddCallback(caps,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(caps,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)21);
  XtAddEventHandler(caps,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  lows=XtVaCreateManagedWidget("Lows",xmDrawnButtonWidgetClass,rc2,
  	XmNlabelType,XmPIXMAP,
  	XmNlabelPixmap,_lows,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,1,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,caps,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);
  XtAddCallback(lows,XmNactivateCallback,(XtCallbackProc)LowsSelection,e);
  XtAddCallback(lows,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(lows,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)22);
  XtAddEventHandler(lows,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  _goto=XtVaCreateManagedWidget("Goto",xmDrawnButtonWidgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,11,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,replall,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNleftOffset,10,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_gotoline,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);
  XtAddCallback(_goto,XmNactivateCallback,(XtCallbackProc)GotoLine,e);
  XtAddCallback(_goto,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(_goto,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)27);
  XtAddEventHandler(_goto,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);
	
  n=0;
  XtSetArg(args[n],XmNtopAttachment,XmATTACH_POSITION);n++;
  XtSetArg(args[n],XmNtopPosition,10);n++;
  XtSetArg(args[n],XmNleftAttachment,XmATTACH_WIDGET);n++;
  XtSetArg(args[n],XmNleftWidget,_goto);n++;
  XtSetArg(args[n],XmNrightAttachment,XmATTACH_NONE);n++;
  XtSetArg(args[n],XmNbottomAttachment,XmATTACH_FORM);n++;
  e->gotofield=CreateComboBox(rc2,"gotofield",args,n,10);
  InitializeComboBox(e->gotofield,editor[0]->gotofield);
  XtAddCallback(e->gotofield,XmNactivateCallback,(XtCallbackProc)GotoLine,e);

  w=XtVaCreateManagedWidget("DBSetMarker",xmDrawnButtonWidgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,1,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,lows,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_setmarker,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	XmNleftOffset,10,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)SetMarker,e);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)23);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);

  w=XtVaCreateManagedWidget("DBGotoMarker",xmDrawnButtonWidgetClass,rc2,
	XmNtopAttachment,XmATTACH_POSITION,
	XmNtopPosition,1,
	XmNleftAttachment,XmATTACH_WIDGET,
	XmNleftWidget,w,
	XmNrightAttachment,XmATTACH_NONE,
	XmNbottomAttachment,XmATTACH_NONE,
	XmNlabelType,XmPIXMAP,
	XmNlabelPixmap,_gotomarker,
	XmNlabelInsensitivePixmap,_gotomarker2,
	XmNhighlightThickness,1,
	XmNpushButtonEnabled,True,
	NULL);

  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)RemoveSmallHelp,(void*)1);
  XtAddCallback(w,XmNactivateCallback,(XtCallbackProc)GotoMarker,e);
  XtAddEventHandler(w,EnterWindowMask,True,(XtEventHandler)SmallHelp,(void*)24);
  XtAddEventHandler(w,LeaveWindowMask,True,(XtEventHandler)RemoveSmallHelp,(void*)0);


  n=0;
  XtSetArg(args[n],XmNtopAttachment,XmATTACH_WIDGET);n++;
  XtSetArg(args[n],XmNtopWidget,rc1);n++;
  XtSetArg(args[n],XmNbottomAttachment,XmATTACH_WIDGET);n++;
  XtSetArg(args[n],XmNbottomWidget,rc2);n++;
  XtSetArg(args[n],XmNleftAttachment,XmATTACH_FORM);n++;
  XtSetArg(args[n],XmNrightAttachment,XmATTACH_FORM);n++;
  XtSetArg(args[n],XmNeditMode,XmMULTI_LINE_EDIT);n++;
/*  XtSetArg(args[7],XmNtranslations,XtParseTranslationTable(translations));*/
  e->text=XmCreateScrolledText(mf,"text",args,n);
  XtManageChild(e->text);
 
  e->tmpsource=XtVaCreateWidget("tmpsource",xmTextWidgetClass,mf,NULL);

  XtAddCallback(e->text,XmNvalueChangedCallback,(XtCallbackProc)ValueChanged,e);
  XtAddCallback(e->text,XmNmotionVerifyCallback,(XtCallbackProc)FindRowCol,e);
  XtAddCallback(e->text,XmNmodifyVerifyCallback,(XtCallbackProc)DeleteText,e);

  e->pm=XmVaCreateSimplePopupMenu(e->text/*mf*/,"Popup",(XtCallbackProc)popup_cb,
	XmVaPUSHBUTTON,NULL,NULL,NULL,NULL,
	XmVaPUSHBUTTON,NULL,NULL,NULL,NULL,
	XmVaPUSHBUTTON,NULL,NULL,NULL,NULL,
	XmVaPUSHBUTTON,NULL,NULL,NULL,NULL,
	XmVaPUSHBUTTON,NULL,NULL,NULL,NULL,
	XmVaPUSHBUTTON,NULL,NULL,NULL,NULL,
	XmVaPUSHBUTTON,NULL,NULL,NULL,NULL,
	NULL);

  for (x=0;x<fl_size;x++)
  {	
    e->filelist[x]=XtVaCreateManagedWidget("filebutton",
     xmPushButtonGadgetClass,e->filemenu,NULL);
    XtAddCallback(e->filelist[x],XmNactivateCallback,(XtCallbackProc)OpenOldFile,(void*)e);
  }
  atom=XmInternAtom(XtDisplay(top),"WM_DELETE_WINDOW",False);
  XmAddWMProtocolCallback(top,atom,(XtCallbackProc)Quit,e);

  XtVaSetValues(top,XmNiconPixmap,pixmap,NULL);

  NoUndo(e);
  e->shell=top;
  e->ats=NULL;
  e->fd=NULL;
  e->iod=NULL;
  e->saved=1;
  e->fs=NULL;
  e->undosize=0;
  e->changes=0;
  e->lastaction=0;
  e->redosize=0;
  e->le=NULL;
  e->se=NULL;
  e->sd=NULL;
  e->err=NULL;
  e->ato=NULL;
  e->gd=NULL;
  e->filename[0]='\0';
  e->tid2=0;
  e->tid3=0;
  e->tid4=0;
  e->tid5=0;
  e->tid6=0;
  e->tid7=0;
  db_strcpy(e->print_command,"lpr");
  db_strcpy(e->compile_command,"cc -c %s");
  db_strcpy(e->make_command,"make");
  db_strcpy(e->run_command,"");
  e->auto_indent=1;
  e->undolevels=100;
  e->tid=0;
  e->workcount=0;
  e->locked=0;
  e->read_only=0;
  e->abd=NULL;
  e->std=NULL;
  e->oldsource=0;
  e->t.pid=0;
  e->new_window=0;
  e->blockundo=1;
  e->autosave=0;
  e->autosavetimeout=5;
  e->ce_count=0;
  e->compiler_error=NULL;
  WriteTime(e,0);
  LoadSettings(e);
  RemoveMarker(e);
  UpdateEditorBookmarks(e);
  editors++;
  UpdateFileList(NULL);
  UpdateEditorDialog();
EP;
}

void CreateNewEditor(void)
{
  Widget shell;
  
SP("CreateNewEditor");
  shell=XtVaAppCreateShell("jex","Jex",topLevelShellWidgetClass,XtDisplay(top),
  	XmNallowShellResize,True,
  	NULL);
  CreateEditor(shell);
  XtVaSetValues(shell,XmNallowShellResize,False,NULL);
  XtPopup(shell,XtGrabNone);
  SetCurrentWidget(editor[editors-1]->text);
EP;
}

int main(argc,argv)
int argc;
char *argv[];
{
  XtActionsRec actions[2];
  int x,y=0;
  Pixel fg,bg;

SP("main");
  top=XtVaAppInitialize(&app,"Jex",NULL,0,&argc,argv,fallbacks,NULL);
  XtGetApplicationResources(top,&ownres,resources,XtNumber(resources),NULL,0);

  combo1=CreateComboBox(NULL,"FSFilterField",NULL,0,10);
  InitializeComboBox(combo1,NULL);
  combo2=CreateComboBox(NULL,"FSFilterDirField",NULL,0,10);
  InitializeComboBox(combo2,NULL);
  combo3=CreateComboBox(NULL,"FSSelectionField",NULL,0,10);
  InitializeComboBox(combo3,NULL);
  combo4=CreateComboBox(NULL,"GrepPattern",NULL,0,10);
  InitializeComboBox(combo4,NULL);
  combo5=CreateComboBox(NULL,"GrepFiles",NULL,0,10);
  InitializeComboBox(combo5,NULL);
  combo6=CreateComboBox(NULL,"GrepReplaceField",NULL,0,10);
  InitializeComboBox(combo6,NULL);

  actions[0].string="PopupMenu";
  actions[0].proc=(XtActionProc)PopupMenu;
  actions[1].string="delete-line";
  actions[1].proc=(XtActionProc)DeleteLine;
  XtAppAddActions(app,actions,2);

  pixmap=CreatePixmapFromXPM(top,jex_xpm);
 /* pixmap=XCreatePixmapFromBitmapData(XtDisplay(top),
		RootWindowOfScreen(XtScreen(top)),
		jex_bits,jex_width,jex_height,
		BlackPixelOfScreen(XtScreen(top)),
		WhitePixelOfScreen(XtScreen(top)),
		DefaultDepthOfScreen(XtScreen(top)));
*/

  XtVaGetValues(top,XmNforeground,&fg,XmNbackground,&bg,NULL);
  lov=XCreatePixmapFromBitmapData(XtDisplay(top),
		RootWindowOfScreen(XtScreen(top)),
		(char*)lov_bits,lov_width,lov_height,
		BlackPixelOfScreen(XtScreen(top)),bg,
		DefaultDepthOfScreen(XtScreen(top)));

  _new=CreatePixmapFromXPM(top,new_data);
  _open=CreatePixmapFromXPM(top,open_data);
  _save=CreatePixmapFromXPM(top,save_data);
  _save2=CreatePixmapFromXPM(top,save2_data);
  _clear=CreatePixmapFromXPM(top,clear_data);
  _clone=CreatePixmapFromXPM(top,clone_data);
  _compile=CreatePixmapFromXPM(top,compile_data);
  _copy=CreatePixmapFromXPM(top,copy_data);
  _cut=CreatePixmapFromXPM(top,cut_data);
  _grep=CreatePixmapFromXPM(top,grep_data);
  _left=CreatePixmapFromXPM(top,left_data);
  _make=CreatePixmapFromXPM(top,make_data);
  _newwind=CreatePixmapFromXPM(top,newwind_data);
  _paste=CreatePixmapFromXPM(top,paste_data);
  _redo=CreatePixmapFromXPM(top,redo_data);
  _right=CreatePixmapFromXPM(top,right_data);
  _undo=CreatePixmapFromXPM(top,undo_data);
  _undo2=CreatePixmapFromXPM(top,undo2_data);
  _redo2=CreatePixmapFromXPM(top,redo2_data);
  _compile2=CreatePixmapFromXPM(top,compile2_data);
  _make2=CreatePixmapFromXPM(top,make2_data);
  _grep2=CreatePixmapFromXPM(top,grep2_data);
  _up=CreatePixmapFromXPM(top,up_data);
  _down=CreatePixmapFromXPM(top,down_data);
  _caps=CreatePixmapFromXPM(top,caps_data);
  _lows=CreatePixmapFromXPM(top,lows_data);
  _setmarker=CreatePixmapFromXPM(top,setmarker_data);
  _gotomarker=CreatePixmapFromXPM(top,gotomarker_data);
  _gotomarker2=CreatePixmapFromXPM(top,gotomarker2_data);
  _down2=CreatePixmapFromXPM(top,down2_data);
  _run=CreatePixmapFromXPM(top,run_data);
  _run2=CreatePixmapFromXPM(top,run2_data);
  _gotoline=CreatePixmapFromXPM(top,gotoline_data);

  CreateBookmarkDialog();
  StartEditor();
  CreateEditor(top);

  XtRealizeWidget(top);
  SetCurrentWidget(editor[editors-1]->text);
  for (x=1;x<argc;x++)
  {
    if (argv[x][0]!='-' && !y)
    {
      loadfile(editor[0],argv[1],0,2);
/*      db_strcpy(editor[0]->filename,argv[1]);
      SetTitle(editor[0],editor[0]->filename);*/
      y=1;
    }
    else if (argv[x][0]!='-' && y)
    {
      CreateNewEditor();
   /*   db_strcpy(editor[editors-1]->filename,argv[x]);
      SetTitle(editor[editors-1],editor[editors-1]->filename);*/
      loadfile(editor[editors-1],argv[x],0,1);
    }
  }
  UpdateEditorDialog();

  XtAppMainLoop(app);
EP;
  return 0;
}

