#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <ctype.h>
#include <sys/stat.h>
#include <Xm/Text.h>
#include <Xm/TextStrSoP.h>
#include <Xm/PushBG.h>
#include "jex.h"
#include "helpstack.h"

#define READSIZE 250000

extern Widget top,bdl,combo1,combo2,combo3,combo4,combo5,combo6;
extern XtAppContext app;
void Terminate();
extern int fl_size;
extern char fl_files[FILELIST][255];
extern OwnRes ownres;
extern List help_topics;
extern HStack *hst;
extern List l;

void SetSave(Editor *e,Boolean enabled)
{
  SP("SetSave");
  XtVaSetValues(e->save,XmNsensitive,enabled,NULL);
  EP;
}

void SetCurrentWidget(Widget w)
{
  Widget tmp;
  
  SP("SetCurrentWidget");
  tmp=w;
  while (!XtIsShell(tmp))
    tmp=XtParent(tmp);
  XmProcessTraversal(tmp,XmTRAVERSE_CURRENT);
  XmProcessTraversal(w,XmTRAVERSE_CURRENT);
  EP;
}

void SetMarker(Widget w,Editor *e,void *cbs)
{
  SP("SetMarker");
  e->marker=XmTextGetInsertionPosition(e->text);
  XtVaSetValues(XtNameToWidget(e->mb,"*editmenu.button_12"),XmNsensitive,True,NULL);
  XtVaSetValues(XtNameToWidget(e->shell,"*DBGotoMarker"),XmNsensitive,True,NULL);
  SetCurrentWidget(e->text);
  EP;
}
 
void GotoMarker(Widget w,Editor *e,void *cbs)
{
  SP("GotoMarker");
  if (e->marker!=-1)
  {
    XmTextSetInsertionPosition(e->text,e->marker);   
    XmTextShowPosition(e->text,e->marker);
  }
  SetCurrentWidget(e->text);
  EP;
}

void RemoveMarker(Editor *e)
{
  SP("RemoveMarker");
  e->marker=-1;
#ifndef LESSTIFF    
  XtVaSetValues(XtNameToWidget(e->mb,"*editmenu.button_12"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->shell,"*DBGotoMarker"),XmNsensitive,False,NULL);
#endif
  EP;
}

int CheckEditor(Editor *e)
{
  int x;
  
SP("CheckEditor");
  for (x=0;x<editors;x++)
  {
    if (editor[x]==e)
    {
      EP;
      return 1;
    }
  }
  EP;
  return 0;
}

void UnlinkFile(Editor *e)
{
  char file[255];
  
SP("UnlinkFile");
  WatchCursor(e,1);
  if (e->filename[0])
  {
    sprintf(file,"%s~",e->filename);
    unlink(file);
  }
  WatchCursor(e,0);
EP;
}

void StartEditor(void)
{
  FILE *f;
  int x,y,z,n,w,v,vc;
  char str[255],ini[255],*param,*home,file[255];
  
SP("StartEditor");
/*  signal(SIGQUIT,Terminate);
  signal(SIGILL,Terminate);
  signal(SIGTRAP,Terminate);
  signal(SIGIOT,Terminate);
  signal(SIGFPE,Terminate);
  signal(SIGKILL,Terminate);
  signal(SIGBUS,Terminate);
  signal(SIGSEGV,Terminate);
  signal(SIGTERM,Terminate);
  signal(SIGHUP,Terminate);
  signal(SIGSTOP,SIG_IGN);
  signal(SIGINT,Terminate);
  signal(SIGIO,SIG_IGN);
  signal(SIGPIPE,SIG_IGN);
  signal(SIGUSR1,SIG_IGN);
  signal(SIGUSR2,SIG_IGN);
  signal(SIGPROF,SIG_IGN);
  signal(SIGABRT,Terminate);*/
  DBInit("jex","jex.log",0,Terminate);
  db_debug_mode=0;
  if ((int)ownres.histhome)
  {
    home=getenv("HOME");
    if (home)
      sprintf(file,"%s/.jexhistory",home);
    else
      db_strcpy(file,".jexhistory");
  }
  else
    db_strcpy(file,".jexhistory");
  if ((f=fopen(file,"r"))==NULL)
  {
    EP;
    return;
  }
  x=0;
  y=0;
  z=0;
  w=0;
  v=0;
  vc=0;
  while (fgets(str,255,f))
  {
    str[db_strlen(str)-1]='\0';
    n=sscanf(str,"%s",ini);
    n=2;
    param=&str[db_strlen(ini)+1];
    if (db_strcmp(ini,"file:")==0 && x<FILELIST)
    {
      db_strcpy(fl_files[x],param);
      if (fl_files[x][0])
        x++;
    }
    else if (db_strcmp(ini,"bookmark:")==0)
    {
      AddBookmark(param);
    }
    else if (db_strcmp(ini,"version:")==0)
    {
      CheckVersion(param);
      vc=1;
    }
    else if (n==1 && x<FILELIST)
    {
      db_strcpy(fl_files[x],ini);
      if (fl_files[x][0])
        x++;
    }
  }
  if (!vc)
    ShowVersion();
  fl_size=x;
  fclose(f);    
EP;
}

void StopEditor(void)
{
  FILE *f;
  int x;
  char *home,file[255],*str;
  int count;
  XmStringTable items;
  HelpTopic ht;

SP("StopEditor");
  if (ownres.histhome)
  {
    home=getenv("HOME");
    if (home)
      sprintf(file,"%s/.jexhistory",home);
    else
      db_strcpy(file,".jexhistory");
  }
  else
    db_strcpy(file,".jexhistory");
  if ((f=db_fopen(file,"w+"))==NULL)
  {
    EP;
    return;
  }
  fprintf(f,"version: %d.%d.%d\n",MAJOR_VERSION,MINOR_VERSION,SUB_MINOR_VERSION);
  for (x=0;x<fl_size;x++)
    fprintf(f,"file: %s\n",fl_files[x]);
  CopyComboBoxToFile(combo1,f);
  CopyComboBoxToFile(combo2,f);
  CopyComboBoxToFile(combo3,f);
  CopyComboBoxToFile(combo4,f);
  CopyComboBoxToFile(combo5,f);
  CopyComboBoxToFile(combo6,f);
  CopyComboBoxToFile(editor[0]->findf,f);
  CopyComboBoxToFile(editor[0]->replf,f);
  CopyComboBoxToFile(editor[0]->gotofield,f);
  XtVaGetValues(bdl,XmNitemCount,&count,XmNitems,&items,NULL);
  for (x=0;x<count;x++)
  {
    XmStringGetLtoR(items[x],XmSTRING_DEFAULT_CHARSET,&str);
    fprintf(f,"bookmark: %s\n",str);
    XtFree(str);
  }
  db_fclose(f);   
  DisposeList(l);
  if (GetFirstElement(help_topics,&ht))
  {
    do
    {
      DisposeList(ht.list);
    } while (GetNextElement(help_topics,&ht));
  }
  DisposeList(help_topics);
  DestroyHStack(hst);
EP;
}

void Exit(Editor *e)
{
  int x,y;
  char file[255];
  
SP("Exit");
  db_strcpy(file,e->filename);
  UnlinkFile(e);
  for (x=0;x<editors;x++)
  {
    if (editor[x]->shell==e->shell)
    {
      XtRemoveAllCallbacks(e->text,XmNvalueChangedCallback);
      XtRemoveAllCallbacks(e->text,XmNmotionVerifyCallback);
      XtRemoveAllCallbacks(e->text,XmNmodifyVerifyCallback);
MP;      XtUnmapWidget(e->shell); 
MP;      XtPopdown(e->shell);
      if (e->iod)
/*        XtUnmanageChild(e->iod);*/
MP,	XtPopdown(e->iod);
      if (e->fs)
MP,        XtUnmanageChild(e->fs);
      if (e->ats)
MP,        XtUnmanageChild(e->ats);
      if (e->fd)
MP,        XtUnmanageChild(e->fd);
      if (e->le)
MP,        XtUnmanageChild(e->le);
      if (e->se)
MP,        XtUnmanageChild(e->se);
      if (e->std)
MP,        XtUnmanageChild(e->std);
      if (e->tid)
MP,        XtRemoveTimeOut(e->tid);
      if (e->tid2)
MP,        XtRemoveTimeOut(e->tid2);
      if (e->tid3)
MP,        XtRemoveTimeOut(e->tid3);
      if (e->tid4)
MP,      XtRemoveTimeOut(e->tid4);
      if (e->tid5)
MP,      XtRemoveTimeOut(e->tid5);
      if (e->tid6)
MP,      XtRemoveTimeOut(e->tid6);
      if (e->tid7)
MP,      XtRemoveTimeOut(e->tid7);
      if (e->t.pid)
      {
MP,     RemoveInputs(e,NULL);
MP,     kill(e->t.pid,SIGKILL);
      }
    if (e->oldsource)
    {
      XmTextSetSource(e->text,XmTextGetSource(e->tmpsource),0,0);
      XtDestroyWidget(e->tmpsource);
      e->tmpsource=XtVaCreateWidget("tmpsource",xmTextWidgetClass,XtParent(XtParent(e->text)),NULL);
      e->oldsource=0;
    }
MP; if (e->ce_count)
    {
      for (y=0;y<e->ce_count;y++)
        db_free(e->compiler_error[y]);
      db_free(e->compiler_error);
      e->compiler_error=NULL;
      e->ce_count=0;
    }    
MP,   XtVaSetValues(e->text,XmNvalue,"",NULL);
MP,   NoUndo(e);
/*      XtDestroyWidget(XtParent(XtParent(e->text)));*/
MP,   DisposeList(e->undolist);
MP,   DisposeList(e->redolist);
      if (editors==1)
        StopEditor();
MP,   db_free((char*)editor[x]);
      if (x<editors-1)
MP,     db_memmove(&editor[x],&editor[x+1],(editors-x-1)*sizeof(Editor*));
MP,   editors--;
MP,   UpdateEditorDialog();
      if (file[0])
MP,     UpdateFileList(file);
      break;
    }
  }
  if (!editors)
  {
/*MP,    StopEditor();*/
       DestroyAllComboBoxes();
MP,    exit(0);
  }
EP;
}

void GetFullFileName(char *file)
{
  char cdir[255],name[255],path[255];
  
SP("GetFullFileName");
  if (file && file[0]=='/')
  {
    EP;
    return;
  }
  db_getcwd(cdir,255);
  SplitPath(file,path,name);
  db_chdir(path);
  db_getcwd(path,255);
  if (path[db_strlen(path)-1]=='/')
    sprintf(file,"%s%s",path,name);
  else
    sprintf(file,"%s/%s",path,name);
  db_chdir(cdir);
EP;
}

void DetachEditor(Editor *e,char* file)
{
SP("DetachEditor");
  if (e->oldsource)
  {
    XmTextSetSource(e->text,XmTextGetSource(e->tmpsource),0,0);
    XtDestroyWidget(e->tmpsource);
    e->tmpsource=XtVaCreateWidget("tmpsource",xmTextWidgetClass,XtParent(XtParent(e->text)),NULL);
    e->oldsource=0;
    if (file)
      loadfile(e,file,0,0);
  }
EP;
}

int loadfile(Editor *e,char *fl,int insert,int setname)
{
  char *str,file[255];
  FILE *f;
  int i,x;
  XmTextPosition pos;
  struct stat sbuf;
  
SP("loadfile");
  db_strcpy(file,fl);
  GetFullFileName(file);
  if ((f=db_fopen(file,"r"))==NULL)
  {
    if (setname==2)
    {
      db_strcpy(e->filename,file);
      SetTitle(e,e->filename);
    }
    SetCurrentWidget(e->text);
EP;
    return 1;
  }
  if (db_stat(file,&sbuf)<0)
  {
    if (db_lstat(file,&sbuf)<0)
    {
      if (setname==2)
      {
        db_strcpy(e->filename,file);
        SetTitle(e,e->filename);
      }
      db_fclose(f);
      SetCurrentWidget(e->text);
      EP;
      return 1;
    }
  }
  if ((sbuf.st_mode&S_IFMT)==S_IFDIR)
  {
    db_fclose(f);
    EP;
    SetCurrentWidget(e->text);
    return 2;
  }
  WatchCursor(e,1);
  if (e->filename[0])
    UpdateFileList(e->filename);
  str=(char*)db_malloc(READSIZE+1);
  if (insert)
    pos=XmTextGetInsertionPosition(e->text);
  else
  {
    DetachEditor(e,file);
    XtVaSetValues(e->text,XmNvalue,"",NULL);
    pos=0;
  }    
  if (!insert)
    XtRemoveAllCallbacks(e->text,XmNmodifyVerifyCallback);
  XtUnmanageChild(e->text);
  do
  {
    i=db_fread(str,1,READSIZE,f);
    str[i]='\0';
    XmTextInsert(e->text,pos,str);
    pos+=i;
  } while (i==READSIZE);
  XtManageChild(e->text);
  if (!insert)
    XtAddCallback(e->text,XmNmodifyVerifyCallback,(XtCallbackProc)DeleteText,e);
  db_free(str);
  db_fclose(f);
  UnlinkFile(e);
  if (!insert)
  {
    NoUndo(e);
    XmTextSetInsertionPosition(e->text,0);
    XmTextShowPosition(e->text,0);
    e->saved=1;
/*    XtUnmanageChild(e->save);*/
    SetSave(e,False);
    for (x=0;x<editors;x++)
    {
      if (editor[x]!=e && db_strcmp(editor[x]->filename,file)==0)
      {
        XmTextSetSource(e->tmpsource,XmTextGetSource(e->text),0,0);
        XmTextSetSource(e->text,XmTextGetSource(editor[x]->text),0,0);
        e->oldsource=1;
        editor[x]->oldsource=1;
        break;
      }
    }
  }
  if (setname)
  {
    db_strcpy(e->filename,file);
    SetTitle(e,e->filename);
  }
  WatchCursor(e,0);
  SetCurrentWidget(e->text);
EP;
  return 0;
}

int savefile(Editor *e,char *file,char *str)
{
  FILE *f;
  char save[512];
  
SP("savefile");
  if (e->read_only)
  {
    EP;
    return 0;
  }
  WatchCursor(e,1);
  if ((f=fopen(file,"r"))!=NULL)
  {
    fclose(f);
    sprintf(save,"%s~",file);
    if ((f=fopen(save,"w+"))!=NULL)
    {
      fclose(f);
      sprintf(save,"cp %s %s~",file,file);
      system(save);
    }
  }
  if ((f=db_fopen(file,"w+"))==NULL)
  {
    WatchCursor(e,0);
    EP;
    return 0;
  }
  if (db_fwrite(str,1,db_strlen(str),f)!=db_strlen(str))
  {
    db_fclose(f);
    WatchCursor(e,0);
    EP;
    return 0;
  }
  db_fclose(f);
  db_strcpy(e->filename,file);
  WatchCursor(e,0);
EP;
  return 1;
}

void CopyFile(char *s,char *t)
{
  char str[255];
  
SP("CopyFile");
  sprintf(str,"cp %s %s",s,t);
  system(str);
EP;
}

void NoHighlight(Editor *e,void *id)
{
SP("NoHighlight");
  XmTextSetHighlight(e->text,0,XmTextGetLastPosition(e->text),XmHIGHLIGHT_NORMAL);
  e->tid5=0;
EP;
}

void GotoLine(Widget w,Editor *e,void *cbs)
{
  int line,x,l=2,len,left;
  char *linestr,*str;

SP("GotoLine");
  WatchCursor(e,1);
#ifdef FAST_GET_TEXT_VALUE
  XmTextSource ts;
  ts=XmTextGetSource(e->text);
  str=((XmTextSourceRec*)ts)->data->ptr;
#else
  XtVaGetValues(e->text,XmNvalue,&str,NULL);  
#endif  
  XtVaGetValues(e->gotofield,XmNvalue,&linestr,NULL);
  for (x=0;x<editors;x++)
    UpdateComboBox(editor[x]->gotofield,linestr);
  line=atoi(linestr);
  XtFree(linestr);
#ifdef FAST_GET_TEXT_VALUE
  len=((XmTextSourceRec*)ts)->data->length;
#else
  len=db_strlen(str);
#endif
  if (line==1)
  {
    XmTextShowPosition(e->text,0);
    XmTextSetInsertionPosition(e->text,0);
#ifndef FAST_GET_TEXT_VALUE  
    XtFree(str);
#endif  
    left=0;
    x=left+1;
    if (str[left]!='\n')
    {
      while (x<len && str[x]!='\n')
        x++;
    }
    XmTextSetHighlight(e->text,left,x,XmHIGHLIGHT_SELECTED);
    e->tid5=XtAppAddTimeOut(app,1000,(XtTimerCallbackProc)NoHighlight,e);
    WatchCursor(e,0);
EP;
    return;
  }
  for (x=0;x<len;x++)
  {
    if (str[x]=='\n')
    {
      if (l==line || line==1)
      {
        XmTextShowPosition(e->text,(x==0)?0:(x+1));
        XmTextSetInsertionPosition(e->text,(x==0)?0:(x+1));
        left=(x==0)?0:(x+1);
        x=left+1;
        if (str[left]!='\n')
        {
          while (x<len && str[x]!='\n')
            x++;
        }
        XmTextSetHighlight(e->text,left,x,XmHIGHLIGHT_SELECTED);
        e->tid5=XtAppAddTimeOut(app,1000,(XtTimerCallbackProc)NoHighlight,e);
        break;
      }      
      l++;
    }
  }
#ifndef FAST_GET_TEXT_VALUE  
  XtFree(str);
#endif  
  SetCurrentWidget(e->text);
  WatchCursor(e,0);
EP;
}

void CalcRowCol(Editor *e,void *ti)
{
  int x=0,l=1,c=1,y=0,col=0;
  char cstr[20],*str;
  XmString xstr;
  XmTextPosition f;
 
#ifdef FAST_GET_TEXT_VALUE
  XmTextSource ts;
SP("CalcRowCol");
  if (!CheckEditor(e))
  {
    Log("Reference to Unknown editor");
    return;
  }
  ts=XmTextGetSource(e->text);
  str=((XmTextSourceRec*)ts)->data->ptr;
#else
SP("CalcRowCol");
  if (!CheckEditor(e))
  {
    Log("Reference to Unknown editor");
    return;
  }
  XtVaGetValues(e->text,XmNvalue,&str,NULL);
#endif
  f=XmTextGetInsertionPosition(e->text);
  for (x=0;x<f;x++)
  {
    if (str[x]=='\n')
    {
      l++;
      y=x+1;
    }
  }
/*  for (x=f-1;x>=0 && str[x]!='\n';x--)
    c++;*/
  for (x=y;x<f;x++)
  {
    if (str[x]=='\t')
    {
      c+=8-col%8;
      col=0;
    }
    else
    {
      c++;
      col++;
    }
  }
  sprintf(cstr,"%d:%d",l,c);
  xstr=XmStringCreateLocalized(cstr);
  XtVaSetValues(e->rowcol,XmNlabelString,xstr,NULL);
  XmStringFree(xstr);
#ifndef FAST_GET_TEXT_VALUE
  XtFree(str);
#endif
  e->tid6=0;
EP;
}

void FindRowCol(Widget w,Editor *e,XmTextVerifyCallbackStruct *cbs)
{
SP("FindRowCol");
  if (e->tid6)
    XtRemoveTimeOut(e->tid6);
  e->tid6=XtAppAddTimeOut(app,250,(XtTimerCallbackProc)CalcRowCol,e);
EP;
}
      
void printfile(Editor *e,char *file)
{
  char lpstr[255];
  
SP("printfile");
  WatchCursor(e,1);
  sprintf(lpstr,"%s %s",e->print_command,file);
  system(lpstr);
  WatchCursor(e,0);
EP;
}

void Terminate(int sig)
{
  char *str;
  int x,y;
  
/*  printf("jex: Terminating on signal %d...\n\n",sig);*/
  StopEditor();
  for (x=0;x<editors;x++)
  {
    if (!editor[x]->saved)
    {
      str=XmTextGetString(editor[x]->text);
      if (editor[x]->filename[0]=='\0')
        db_strcpy(editor[x]->filename,tempnam(".","jex"));
      else
        db_strcat(editor[x]->filename,".rescue");
      if (savefile(editor[x],editor[x]->filename,str)!=0)
      {
        printf("A copy of your edit file has been saved to '%s'\n",editor[x]->filename);
        db_strcat(editor[x]->filename,"~");
        unlink(editor[x]->filename);
      }
      else
        printf("Sorry, but I was unable to save a copy of your edit file!\n");
      XtFree(str);
    }
    if (editor[x]->ce_count)
    {
      for (y=0;y<editor[x]->ce_count;y++)
        db_free(editor[x]->compiler_error[y]);
      db_free(editor[x]->compiler_error);
    }    
    NoUndo(editor[x]);
    DisposeList(editor[x]->undolist);
    DisposeList(editor[x]->redolist);
    db_free((char*)editor[x]);
  }
  DestroyAllComboBoxes();
  printf("\nPlease send a copy of the file jex.log to: jbosman@village.uunet.be\n");
  printf("                                       or: jbosma@fercomsys.be\n");
  printf("and describe what you were doing to make jex crash.\n");
/*  exit(sig);*/
}

