#include "jex.h"
#include <Xm/Text.h>

extern XtAppContext app;

void SearchChar(Editor *e,char *str,int pos,int direction,char sch,char ech)
{
  int matches=1,len,comment=0,origpos=pos;
  
SP("SearchChar");
  len=db_strlen(str);
  while (pos>=0 && pos<len && matches)
  {
    if (str[pos]==sch && !comment)
      matches++;
    else if (str[pos]==ech && !comment)
      matches--;
    else if (str[pos]=='"' && comment!=2)
    {
      if ((pos && str[pos-1]!='\\') || (pos>1 && str[pos-2]=='\\'))
        comment=comment?0:1;
    }
    else if (str[pos]=='\'' && comment!=1)
    {
      if ((pos && str[pos-1]!='\\') || (pos>1 && str[pos-2]=='\\'))
        comment=comment?0:2;
    }
    pos+=direction;
  }
  if (!matches)
  {
    pos-=direction;
    XmTextShowPosition(e->text,pos);
    XmTextSetInsertionPosition(e->text,pos);
    XmTextSetSelection(e->text,pos,pos,0);
    XmTextSetHighlight(e->text,pos,pos+1,XmHIGHLIGHT_SELECTED);
    XmTextSetHighlight(e->text,origpos-direction,origpos-direction+1,XmHIGHLIGHT_SELECTED);
    e->tid5=XtAppAddTimeOut(app,250,(XtTimerCallbackProc)NoHighlight,e);
  }
EP;
}   

void FindMatchingChar(Widget w,Editor *e,void *cbs)
{
  char sch,ech,*str;
  int direction;
  XmTextPosition pos,right;
  
SP("FindMatchingChar");
  XmTextGetSelectionPosition(e->text,&pos,&right);
  if (pos==right)
    pos=XmTextGetCursorPosition(e->text);
  str=XmTextGetString(e->text);
  if (db_strlen(str)==0)
  {
    XtFree(str);
EP;
    return;
  }
  sch=str[pos];
  switch (str[pos])
  {
    case '(': direction=1;ech=')';break;
    case '{': direction=1;ech='}';break;
    case '[': direction=1;ech=']';break;
    case ')': direction=-1;ech='(';break;
    case '}': direction=-1;ech='{';break;
    case ']': direction=-1;ech='[';break;
    default: XtFree(str);EP;return;
  }
  SearchChar(e,str,pos+direction,direction,sch,ech);
  XtFree(str);
EP;
}  
