#include <Xm/TextStrSoP.h>
#include <Xm/Text.h>
#include "jex.h"

extern Widget text;

void RemoveTabs(char **str)
{
  int col=0,x;
  
SP("RemoveTabs");
  for (x=0;x<strlen(*str);x++)
  {
    if ((*str)[x]=='\n')
      col=0;
    else if ((*str)[x]=='\t')
    {
      *str=XtRealloc(*str,strlen(*str)+8-col%8+1);
      memmove(&(*str)[x+8-col%8],&(*str)[x+1],strlen(&(*str)[x+1])+1);
      memset(&(*str)[x],' ',8-col%8);
      col++;
    }
    else
      col++;
  }
EP;
}

void ShiftRight(Widget w,Editor *e,void *cbs)
{
  char *str;  
  XmTextPosition left,right;
  int len,pos=0,selection=1,nl=1;
  
SP("ShiftRight");
  if (e->read_only)
  {
EP;
    return;
  }
  WatchCursor(e,1);
  XtVaGetValues(e->text,XmNvalue,&str,NULL);
  len=db_strlen(str);
  if (!XmTextGetSelectionPosition(e->text,&left,&right) || left==right)
  {
    left=right=XmTextGetInsertionPosition(e->text);
    selection=0;
  }
  while (left>0 && str[left-1]!='\0' && str[left-1]!='\n')
    left--;
  if ((right && str[right-1]!='\n') || right!=left)
    right--;
  while (right>=0 && right<len && str[right]!='\0' && str[right]!='\n')
    right++;
  if (left>=right)
  {
    XtFree(str);
    WatchCursor(e,0);
EP;
    return;
  }
  XtFree(str);
  XmTextSetSelection(e->text,left,right,0);
  str=XmTextGetSelection(e->text);
  RemoveTabs(&str);
  while (pos<db_strlen(str))
  {
    if (!pos || (pos && str[pos-1]=='\n'))
      nl=1;
    if (nl && str[pos]!=' ' && str[pos]!='\t')
    {
      str=XtRealloc(str,db_strlen(str)+2);
      db_memmove(&str[pos+1],&str[pos],db_strlen(str)-pos+1);
      str[pos]=' ';
      nl=0;
    }
    pos++;
  }
  XmTextReplace(e->text,left,right,str);
  if (selection)
    XmTextSetSelection(e->text,left,left+db_strlen(str),0);
  XtFree(str);
  SetCurrentWidget(e->text);
  WatchCursor(e,0);
EP;
}

void ShiftLeft(Widget w,Editor *e,void *cbs)
{
  char *str;  
  XmTextPosition left,right;
  int len,pos=0,selection=1,nl=0;
  
SP("ShiftLeft");
  if (e->read_only)
  {
    EP;
    return;
  }
  WatchCursor(e,1);
  XtVaGetValues(e->text,XmNvalue,&str,NULL);
  len=db_strlen(str);
  if (!XmTextGetSelectionPosition(e->text,&left,&right) || left==right)
  {
    left=right=XmTextGetInsertionPosition(e->text);
    selection=0;
  }
  while (left>0 && str[left-1]!='\0' && str[left-1]!='\n')
    left--;
  if ((right && str[right-1]!='\n') || right!=left)
    right--;
  while (right>=0 && right<len && str[right]!='\0' && str[right]!='\n')
    right++;
  if (left>=right)
  {
    XtFree(str);
    WatchCursor(e,0);
    EP;
    return;
  }
  XtFree(str);
  XmTextSetSelection(e->text,left,right,0);
  str=XmTextGetSelection(e->text);
  RemoveTabs(&str);
  while (pos<db_strlen(str))
  {
    if ((!pos || (pos && str[pos-1]=='\n')))
      nl=2;
/*    if (nl && str[pos]=='\t')
    {
      str=XtRealloc(str,db_strlen(str)+10);
      db_memmove(&str[pos+8],&str[pos+1],db_strlen(str)-pos+1);
      str[pos]=' ';
      str[pos+1]=' ';
      str[pos+2]=' ';
      str[pos+3]=' ';
      str[pos+4]=' ';
      str[pos+5]=' ';
      str[pos+6]=' ';
      str[pos+7]=' ';
    }*/
    if (nl==2 && str[pos]==' ')
    {
      db_memmove(&str[pos],&str[pos+1],db_strlen(str)-pos);
      nl=1;
    }
    if (nl && str[pos]!=' ' && str[pos]!='\t')
      nl=0;
    pos++;
  }
  XmTextReplace(e->text,left,right,str);
  if (selection)
    XmTextSetSelection(e->text,left,left+db_strlen(str),0);
  XtFree(str);
  SetCurrentWidget(e->text);
  WatchCursor(e,0);
EP;
}

