#include "jex.h"
#include <Xm/RowColumn.h>
#include <X11/cursorfont.h>
XtIntervalId sh_timer=0,sh_timer2=0;
struct {
	 Widget w,menu;
	 int topic,n;
	 XEvent event;
       } sh_topic;
extern XtAppContext app;

void SetLeave(void *n,XtIntervalId tid)
{
  SP("SetLeave");
  XtAddEventHandler(sh_topic.w,LeaveWindowMask,False,(XtEventHandler)RemoveSmallHelp,NULL);
  EP;
}

void ShowSmallHelp(void *n,XtIntervalId tid)
{
  XButtonPressedEvent xbe;
  XmString xstr;
  Position y,y2,h,x,x2,w;
  Widget tmp;
  static Cursor cursor=0;

  SP("ShowSmallHalp");
  sh_topic.n=2;
/*  XtRemoveEventHandler(sh_topic.w,LeaveWindowMask,False,(XtEventHandler)RemoveSmallHelp,NULL);*/
  switch (sh_topic.topic)
  {
    case 1: xstr=XmStringCreateLocalized("New");break;
    case 2: xstr=XmStringCreateLocalized("Open");break;
    case 3: xstr=XmStringCreateLocalized("Save");break;
    case 4: xstr=XmStringCreateLocalized("New Window");break;
    case 5: xstr=XmStringCreateLocalized("Clone");break;
    case 6: xstr=XmStringCreateLocalized("Cut");break;
    case 7: xstr=XmStringCreateLocalized("Copy");break;
    case 8: xstr=XmStringCreateLocalized("Paste");break;
    case 9: xstr=XmStringCreateLocalized("Clear");break;
    case 10: xstr=XmStringCreateLocalized("Undo");break;
    case 11: xstr=XmStringCreateLocalized("Redo");break;
    case 12: xstr=XmStringCreateLocalized("Shift left");break;
    case 13: xstr=XmStringCreateLocalized("Shift right");break;
    case 14: xstr=XmStringCreateLocalized("Compile");break;
    case 15: xstr=XmStringCreateLocalized("Make");break;
    case 16: xstr=XmStringCreateLocalized("Grep");break;
    case 17: xstr=XmStringCreateLocalized("Find downward");break;
    case 18: xstr=XmStringCreateLocalized("Find upward");break;
    case 19: xstr=XmStringCreateLocalized("Replace downward");break;
    case 20: xstr=XmStringCreateLocalized("Replace all");break;
    case 21: xstr=XmStringCreateLocalized("Capitals");break;
    case 22: xstr=XmStringCreateLocalized("Lowers");break;
    case 23: xstr=XmStringCreateLocalized("Set marker");break;
    case 24: xstr=XmStringCreateLocalized("Goto marker");break;
    case 25: xstr=XmStringCreateLocalized("Goto line number");break;
    case 26: xstr=XmStringCreateLocalized("Run");break;
    case 27: xstr=XmStringCreateLocalized("Goto line");break;
    default: xstr=XmStringCreateLocalized("Unknown");break;
  }    
  sh_topic.menu=XmVaCreateSimplePopupMenu(sh_topic.w,"SmallHelpPopup",NULL,
  	XmVaTITLE,xstr,NULL,NULL,NULL,
	NULL);
  if(!cursor)
    cursor = XCreateFontCursor(XtDisplay(sh_topic.menu), XC_top_left_arrow);
  XmSetMenuCursor(XtDisplay(sh_topic.menu),cursor);
  XmStringFree(xstr);
  xbe=*(XButtonPressedEvent*)&sh_topic.event;
  tmp=XtParent(sh_topic.w);
  y2=0;
  x2=0;
  while (!XtIsShell(tmp))
  {
    XtVaGetValues(tmp,XmNx,&x,XmNy,&y,NULL);
    x2+=x;
    y2+=y;
    tmp=XtParent(tmp);
  }
  XtVaGetValues(sh_topic.w,XmNx,&x,XmNy,&y,XmNwidth,&w,XmNheight,&h,NULL);
  xbe.y_root=y2+y+h;
  xbe.x_root=x2+x+w;
  XmMenuPosition(sh_topic.menu,&xbe);
  XtVaSetValues(sh_topic.menu,XmNx,xbe.x_root,XmNy,xbe.y_root,NULL);
  XtManageChild(sh_topic.menu);
/*  XtAppAddTimeOut(app,10,(XtTimerCallbackProc)SetLeave,NULL);*/
  sh_timer=0;
  EP;
}

void DoNothing(void *n,XtIntervalId tid)
{
  SP("DoNothing");
  sh_timer2=0;
  EP;
}

void SmallHelp(Widget w,int n,XEvent *event)
{
  SP("SmallHelp");
  sh_topic.w=w;
  sh_topic.topic=n;
  sh_topic.event=*event;
  sh_topic.n=1;
  if (sh_timer2)
  {
    XtRemoveTimeOut(sh_timer2);
    sh_timer2=XtAppAddTimeOut(app,200,(XtTimerCallbackProc)DoNothing,NULL);
    if (sh_timer)
      XtRemoveTimeOut(sh_timer);
    sh_timer=XtAppAddTimeOut(app,200,(XtTimerCallbackProc)ShowSmallHelp,NULL);
  }
  else if (sh_timer)
  {
    XtRemoveTimeOut(sh_timer);
    sh_timer=XtAppAddTimeOut(app,200,(XtTimerCallbackProc)ShowSmallHelp,NULL);
  }
  else
    sh_timer=XtAppAddTimeOut(app,1000,(XtTimerCallbackProc)ShowSmallHelp,NULL);
  EP;
}

void RemoveSmallHelp(Widget w,int n,void *cbs)
{
  static Cursor cursor=0;
  Widget tmp;
  int x;

  SP("RemoveSmallHelp");
  if (sh_timer)
  {
    XtRemoveTimeOut(sh_timer);
    sh_timer=0;
  }
  sh_topic.n--;
  if ((!sh_topic.n || n) && sh_topic.menu)
  {
    if(!cursor)
      cursor = XCreateFontCursor(XtDisplay(sh_topic.menu), XC_arrow);
    XmSetMenuCursor(XtDisplay(sh_topic.menu),cursor);
    XtUnmanageChild(sh_topic.menu);
    XtDestroyWidget(sh_topic.menu);
    sh_topic.menu=NULL;
    sh_timer2=XtAppAddTimeOut(app,500,(XtTimerCallbackProc)DoNothing,NULL);
  }
  tmp=w;
  while (!XtIsShell(tmp))
    tmp=XtParent(tmp);
  for (x=0;x<editors;x++)
  {
    if (editor[x]->shell==tmp)
      SetCurrentWidget(editor[x]->text);
  }  
  EP;
}

