#include <Xm/Form.h>
#include <Xm/MessageB.h>
#include <Xm/TextF.h>
#include <Xm/LabelG.h>
#include "jex.h"

extern XtAppContext app;

void GetStatistics(Editor *e,XtIntervalId tid)
{
  int len,ln,x;
  char *str,tmp[30];
  
SP("GetStatistics");
  XtVaGetValues(e->text,XmNvalue,&str,NULL);
  len=db_strlen(str);
  ln=1;
  for (x=0;x<len;x++)
  {
    if (str[x]=='\n')
      ln++;
  }
  XtFree(str);
  sprintf(tmp,"%d",ln);
  XtVaSetValues(e->statln,XmNvalue,tmp,NULL);
  sprintf(tmp,"%d",len);
  XtVaSetValues(e->statch,XmNvalue,tmp,NULL);
  sprintf(tmp,"%d",e->changes);
  XtVaSetValues(e->statchan,XmNvalue,tmp,NULL);
  sprintf(tmp,"%d",e->undosize);
  XtVaSetValues(e->statundo,XmNvalue,tmp,NULL);
  sprintf(tmp,"%d",e->redosize);
  XtVaSetValues(e->statredo,XmNvalue,tmp,NULL);
  e->tid3=XtAppAddTimeOut(app,5000,(XtTimerCallbackProc)GetStatistics,(void*)e);
EP;
}

void StatOK(Widget w,Editor *e,void *cbs)
{
SP("StatOK");
  if (e->tid3)
    XtRemoveTimeOut(e->tid3);
  SetCurrentWidget(e->text);
EP;
}

void StatCancel(Widget w,Editor *e,void *cbs)
{
SP("StatCancel");
  SetCurrentWidget(e->text);
EP;
}

void ShowStats(Editor *e)
{
  Widget f,w1;
  
SP("ShowStats");
  WatchCursor(e,1);
  if (e->std==NULL)
  {
    e->std=XmCreateMessageDialog(e->shell,"StatDialog",NULL,0);
    XtUnmanageChild(XmMessageBoxGetChild(e->std,XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(e->std,XmDIALOG_HELP_BUTTON));
    XtAddCallback(e->std,XmNokCallback,(XtCallbackProc)StatOK,(void*)e);
    XtAddCallback(e->std,XmNcancelCallback,(XtCallbackProc)StatCancel,(void*)e);
    f=XtVaCreateManagedWidget("StatForm",xmFormWidgetClass,e->std,
    	XmNfractionBase,2,NULL);
    w1=XtVaCreateManagedWidget("StatLinesLabel",xmLabelGadgetClass,f,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNrightAttachment,XmATTACH_POSITION,
    	XmNrightPosition,1,
    	XmNtopOffset,5,
    	NULL);
    e->statln=XtVaCreateManagedWidget("StatLinesField",xmTextFieldWidgetClass,f,
    	XmNtopAttachment,XmATTACH_FORM,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,w1,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNeditable,False,
    	NULL);
    w1=XtVaCreateManagedWidget("StatCharsLabel",xmLabelGadgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,e->statln,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNtopOffset,5,
    	XmNrightAttachment,XmATTACH_POSITION,
    	XmNrightPosition,1,
    	NULL);
    e->statch=XtVaCreateManagedWidget("StatCharsField",xmTextFieldWidgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,e->statln,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,w1,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNeditable,False,
    	NULL);
    w1=XtVaCreateManagedWidget("StatChangesLabel",xmLabelGadgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,e->statch,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNtopOffset,5,
    	XmNrightAttachment,XmATTACH_POSITION,
    	XmNrightPosition,1,
    	NULL);
    e->statchan=XtVaCreateManagedWidget("StatChangesField",xmTextFieldWidgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,e->statch,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,w1,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNeditable,False,
    	NULL);
    w1=XtVaCreateManagedWidget("StatUndoLabel",xmLabelGadgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,e->statchan,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNtopOffset,5,
    	XmNrightAttachment,XmATTACH_POSITION,
    	XmNrightPosition,1,
    	NULL);
    e->statundo=XtVaCreateManagedWidget("StatUndoField",xmTextFieldWidgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,e->statchan,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,w1,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNeditable,False,
    	NULL);
    w1=XtVaCreateManagedWidget("StatRedoLabel",xmLabelGadgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,e->statundo,
    	XmNleftAttachment,XmATTACH_FORM,
    	XmNtopOffset,5,
    	XmNrightAttachment,XmATTACH_POSITION,
    	XmNrightPosition,1,
    	NULL);
    e->statredo=XtVaCreateManagedWidget("StatRedoField",xmTextFieldWidgetClass,f,
    	XmNtopAttachment,XmATTACH_WIDGET,
    	XmNtopWidget,e->statundo,
    	XmNleftAttachment,XmATTACH_WIDGET,
    	XmNleftWidget,w1,
    	XmNrightAttachment,XmATTACH_FORM,
    	XmNeditable,False,
    	NULL);
  }
  if (!e->tid3)
    e->tid3=XtAppAddTimeOut(app,5000,(XtTimerCallbackProc)GetStatistics,(void*)e);
  XtManageChild(e->std);
  GetStatistics(e,0);
  WatchCursor(e,0);
EP;
}

