#include <Xm/Text.h>
#include <stdlib.h>
#include "jex.h"

void NoUndo(Editor *e)
{
  Undo_T tundo;
  
SP("NoUndo");
  while (GetFirstElement(e->undolist,&tundo))
  {
    if (tundo.deletesize)
      db_free(tundo.undelete);
    DeleteFirstElement(e->undolist);
  }
  while (GetFirstElement(e->redolist,&tundo))
  {
    if (tundo.deletesize)
      db_free(tundo.undelete);
    DeleteFirstElement(e->redolist);
  }
  e->undosize=0;
  e->changes=0;
  e->redosize=0;
  XtVaSetValues(e->undo,XmNsensitive,False,NULL);
  XtVaSetValues(e->redo,XmNsensitive,False,NULL);
#ifndef LESSTIFF
  XtVaSetValues(XtNameToWidget(e->mb,"*editmenu.button_0"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->mb,"*editmenu.button_1"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->text,"*Popup.button_4"),XmNsensitive,False,NULL);
  XtVaSetValues(XtNameToWidget(e->text,"*Popup.button_5"),XmNsensitive,False,NULL);
#endif  
EP;
}   

void DeleteText(Widget w,Editor *e,XmTextVerifyCallbackStruct *cbs)
{
  char *buf;
  Undo_T tundo,pu;
  int changed=0;
 
SP("DeleteText");
  if (e->lastaction!=1 && e->undosize>e->undolevels)
  {
    GetFirstElement(e->undolist,&tundo);
    if (tundo.deletesize)
      db_free(tundo.undelete);
    e->undosize--;
    DeleteFirstElement(e->undolist);
  }
  else if (e->lastaction==1 && e->redosize>e->undolevels)
  {
    GetFirstElement(e->redolist,&tundo);
    if (tundo.deletesize)
      db_free(tundo.undelete);
    e->redosize--;
    DeleteFirstElement(e->redolist);
  }
  tundo.insertsize=cbs->text->length;
  tundo.pos=cbs->startPos;
  if (cbs->startPos!=cbs->endPos)
  {
    tundo.deletesize=cbs->endPos-cbs->startPos;
    if (e->marker!=-1)
    {
      if (e->marker>=cbs->endPos)
        e->marker-=tundo.deletesize;
      else if (e->marker>=cbs->startPos && e->marker<cbs->endPos)
        RemoveMarker(e);
    }
    XtVaGetValues(w,XmNvalue,&buf,NULL);
    if ((tundo.undelete=(char*)db_malloc(tundo.deletesize+1))==NULL)
    {
      XtFree(buf);
EP;
      return;
    }
    db_strncpy(tundo.undelete,&buf[cbs->startPos],tundo.deletesize); 
    tundo.undelete[tundo.deletesize]='\0';     
    XtFree(buf); 
  }
  else
  {
    tundo.deletesize=0;
  }
  if (e->marker>=cbs->startPos)
    e->marker+=tundo.insertsize;
  if (e->lastaction==1)
  {
    AddElement(e->redolist,&tundo);
    e->lastaction=0;
    if (!e->redosize)
    {
      XtVaSetValues(e->redo,XmNsensitive,True,NULL);
#ifndef LESSTIFF    
      XtVaSetValues(XtNameToWidget(e->mb,"*editmenu.button_1"),XmNsensitive,True,NULL);
      XtVaSetValues(XtNameToWidget(e->text,"*Popup.button_5"),XmNsensitive,True,NULL);
#endif
    }
    e->redosize++;
  }
  else
  {
    if (e->blockundo)
    {
      if (GetLastElement(e->undolist,&pu))
      {
        if (/*pu.insertsize && !pu.deletesize &&*/ tundo.insertsize && !tundo.deletesize &&
            tundo.pos-pu.insertsize==pu.pos)
        {
          pu.insertsize+=tundo.insertsize;
          ReplaceCurrentElement(e->undolist,&pu);
          changed=1;
        }
        else if (!pu.insertsize && pu.deletesize && !tundo.insertsize && tundo.deletesize &&
            tundo.pos==pu.pos)
        {
          pu.undelete=db_realloc(pu.undelete,pu.deletesize+tundo.deletesize+1);
          db_memcpy(&pu.undelete[pu.deletesize],tundo.undelete,tundo.deletesize+1);
          pu.deletesize+=tundo.deletesize;
          db_free(tundo.undelete);
          ReplaceCurrentElement(e->undolist,&pu);
          changed=1;
        }
        else if (!pu.insertsize && pu.deletesize && !tundo.insertsize && tundo.deletesize &&
            pu.pos-tundo.deletesize==tundo.pos)
        {
          tundo.undelete=db_realloc(tundo.undelete,tundo.deletesize+pu.deletesize+1);
          db_memcpy(&tundo.undelete[tundo.deletesize],pu.undelete,pu.deletesize+1);
          tundo.deletesize+=pu.deletesize;
          db_free(pu.undelete);
          ReplaceCurrentElement(e->undolist,&tundo);
          changed=1;
        }
      }
    }
    if (!changed)
    {
      AddElement(e->undolist,&tundo);
      if (!e->undosize)
      {
        XtVaSetValues(e->undo,XmNsensitive,True,NULL);
#ifndef LESSTIFF    
        XtVaSetValues(XtNameToWidget(e->mb,"*editmenu.button_0"),XmNsensitive,True,NULL);
        XtVaSetValues(XtNameToWidget(e->text,"*Popup.button_4"),XmNsensitive,True,NULL);
#endif
      }
      e->undosize++;
      e->changes++;
    }
    if (!e->lastaction)
    {
      while (GetFirstElement(e->redolist,&tundo))
      {
        if (tundo.deletesize)
          db_free(tundo.undelete);
        DeleteFirstElement(e->redolist);
      }
      e->redosize=0;
      XtVaSetValues(e->redo,XmNsensitive,False,NULL);
#ifndef LESSTIFF    
      XtVaSetValues(XtNameToWidget(e->mb,"*editmenu.button_1"),XmNsensitive,False,NULL);
      XtVaSetValues(XtNameToWidget(e->text,"*Popup.button_5"),XmNsensitive,False,NULL);
#endif
    }
    else
      e->lastaction=0;
  }
EP;
}

void UndoAction(Widget w,Editor *e,void *cbs)
{
  Undo_T tundo;
  int is,ds;
  
SP("UndoAction");
  if (e->read_only)
  {
    SetCurrentWidget(e->text);
EP;  
    return;
  }
  if (!GetLastElement(e->undolist,&tundo))
  {
    SetCurrentWidget(e->text);
EP;
    return;
  }
  WatchCursor(e,1);
  do
  {
    is=tundo.insertsize;
    ds=tundo.deletesize;
    e->lastaction=1;
    e->undosize--;
    e->changes--;
    if (!e->undosize)
    {
      XtVaSetValues(e->undo,XmNsensitive,False,NULL);
#ifndef LESSTIFF    
      XtVaSetValues(XtNameToWidget(e->mb,"*editmenu.button_0"),XmNsensitive,False,NULL);
      XtVaSetValues(XtNameToWidget(e->text,"*Popup.button_4"),XmNsensitive,False,NULL);
#endif
    }
    if (tundo.insertsize && tundo.deletesize)
    {
      XmTextReplace(e->text,tundo.pos,tundo.insertsize+tundo.pos,tundo.undelete);
      db_free(tundo.undelete);
      XmTextSetInsertionPosition(e->text,tundo.pos+tundo.deletesize);
    }
    else if (tundo.insertsize)
    {
      XmTextReplace(e->text,tundo.pos,tundo.pos+tundo.insertsize,"");
      XmTextSetInsertionPosition(e->text,tundo.pos+tundo.insertsize);
    }
    else if (tundo.deletesize)
    {
      XmTextInsert(e->text,tundo.pos,tundo.undelete);
      db_free(tundo.undelete);
      XmTextSetInsertionPosition(e->text,tundo.pos+tundo.deletesize);
    }
    DeleteLastElement(e->undolist);
    if (!GetLastElement(e->undolist,&tundo))
      break;
  } while (e->blockundo && tundo.insertsize==is && tundo.deletesize==ds);
  if (!e->changes)
  {
/*    XtUnmanageChild(e->save);*/
    SetSave(e,False);

    e->saved=1;
  }
  SetCurrentWidget(e->text);
  WatchCursor(e,0);
EP;
}

void RedoAction(Widget w,Editor *e,void *cbs)
{
  Undo_T undo;
  int is,ds;
  
SP("RedoAction");
  if (e->read_only)
  {
    SetCurrentWidget(e->text);
EP;  
    return;
  }
  if (!GetLastElement(e->redolist,&undo))
  {
    SetCurrentWidget(e->text);
EP;  
    return;
  }
  WatchCursor(e,1);
  do
  {
    is=undo.insertsize;
    ds=undo.deletesize;
    e->redosize--;
    if (!e->redosize)
    {
      XtVaSetValues(e->redo,XmNsensitive,False,NULL);
#ifndef LESSTIFF    
      XtVaSetValues(XtNameToWidget(e->mb,"*editmenu.button_1"),XmNsensitive,False,NULL);
      XtVaSetValues(XtNameToWidget(e->text,"*Popup.button_5"),XmNsensitive,False,NULL);
#endif
    }
    e->lastaction=2;
    if (undo.insertsize && undo.deletesize)
    {
      XmTextReplace(e->text,undo.pos,undo.insertsize+undo.pos,undo.undelete);
      db_free(undo.undelete);
      XmTextSetInsertionPosition(e->text,undo.pos+undo.deletesize);
    }
    else if (undo.insertsize)
    {
      XmTextReplace(e->text,undo.pos,undo.pos+undo.insertsize,"");
      XmTextSetInsertionPosition(e->text,undo.pos+undo.insertsize);
    }
    else if (undo.deletesize)
    {
      XmTextInsert(e->text,undo.pos,undo.undelete);
      db_free(undo.undelete);
      XmTextSetInsertionPosition(e->text,undo.pos+undo.deletesize);
    }
    DeleteLastElement(e->redolist);
    if (!GetLastElement(e->redolist,&undo))
      break;
  } while (e->blockundo && is==undo.insertsize && ds==undo.deletesize);
  SetCurrentWidget(e->text);
  WatchCursor(e,0);
EP;
}

void RepeatAction(Widget w,Editor *e,void *cbs)
{
  Undo_T tundo;
  int is,ds,tmp;
  char *str;
  XmTextPosition pos,curpos;
  
SP("RepeatAction");
  if (e->read_only)
  {
    SetCurrentWidget(e->text);
EP;  
    return;
  }
  if (!GetLastElement(e->undolist,&tundo))
  {
    SetCurrentWidget(e->text);
EP;
    return;
  }
  WatchCursor(e,1);
  is=tundo.insertsize;
  ds=tundo.deletesize;
  curpos=XmTextGetInsertionPosition(e->text);
  if (tundo.insertsize && tundo.deletesize)
  {
    XmTextSetSelection(e->text,tundo.pos,tundo.insertsize+tundo.pos,0);
    str=XmTextGetSelection(e->text);
    if (XmTextFindString(e->text,curpos,tundo.undelete,XmTEXT_FORWARD,&pos))
    {    
      XmTextReplace(e->text,pos,tundo.deletesize+pos,str);
      XmTextSetSelection(e->text,0,0,0);
      XmTextSetInsertionPosition(e->text,pos+tundo.insertsize);
    }
    else
    {
      XmTextSetSelection(e->text,0,0,0);
      XmTextSetInsertionPosition(e->text,curpos);
    }
    XtFree(str);
  }
  else if (tundo.deletesize)
  {
    if (XmTextFindString(e->text,curpos,tundo.undelete,XmTEXT_FORWARD,&pos))
    {    
      XmTextReplace(e->text,pos,tundo.deletesize+pos,"");
      XmTextSetInsertionPosition(e->text,pos);
    }
  }
  else if (tundo.insertsize)
  {
    XmTextSetSelection(e->text,tundo.pos,tundo.insertsize+tundo.pos,0);
    str=XmTextGetSelection(e->text);
    tmp=e->blockundo;
    e->blockundo=0;
    XmTextInsert(e->text,curpos,str);
    e->blockundo=tmp;
    XmTextSetSelection(e->text,0,0,0);
    XmTextSetInsertionPosition(e->text,curpos+strlen(str));
    XtFree(str);
  }
  SetCurrentWidget(e->text);
  WatchCursor(e,0);
EP;
}

