#include <X11/cursorfont.h>
#include "jex.h"
 
extern Widget top;

void WatchCursor(Editor *e,int turn_on)
{
    static Cursor cursor=0;
    XSetWindowAttributes attrs;
    Display *disp;

SP("WatchCursor");
    disp=XtDisplay(top);
    /* "locked" keeps track if we've already called the function.
       This allows recursion and is necessary for most situations;
    */
    turn_on ? e->locked++ : e->locked--;
    if (e->locked<0)
      e->locked=0;
    if(e->locked > 1 || ( e->locked ==1 && turn_on == False ))
    {
EP;    
                return;         /* already locked and we're not unlocking */
    }

    if(!cursor)         /* if not initialized do it */
        cursor = XCreateFontCursor(disp, XC_watch);
    /* if "turn_on" is true, then turn on watch cursor, otherwise, return
       the shell's cursor to normal
    */
    attrs.cursor = turn_on ? cursor : None;

    XChangeWindowAttributes(disp,XtWindow(top),CWCursor,&attrs);
    if (e->fd)
      XChangeWindowAttributes(disp,XtWindow(e->fd),CWCursor,&attrs);
    if (e->iod)
    {
      if (XtWindowOfObject(e->iod))
        XChangeWindowAttributes(disp,XtWindowOfObject(e->iod),CWCursor,&attrs);
      else if (XtWindow(e->iod))
        XChangeWindowAttributes(disp,XtWindow(e->iod),CWCursor,&attrs);
    }
    if (e->shell)
      XChangeWindowAttributes(disp,XtWindow(e->shell),CWCursor,&attrs);
    if (e->sd)
      XChangeWindowAttributes(disp,XtWindow(e->sd),CWCursor,&attrs);
    if (e->abd)
      XChangeWindowAttributes(disp,XtWindow(e->abd),CWCursor,&attrs);
    if (e->gd)
      XChangeWindowAttributes(disp,XtWindow(e->gd),CWCursor,&attrs);

    XFlush(disp);
EP;
} 

