#include <Xm/Xm.h>
#include <stdio.h>
#include "xpm.h"
#include "jbdbg.h"

Pixmap CreatePixmapFromXPM(Widget top,char **data)
{
  XGCValues gcv;
  GC gc;
  Pixmap pixmap=0;
  XColor xc[256];
  int width,height,colors,chars;
  char c_char;
  char color[20];
  int x,y;
  Colormap cm;
  unsigned long mask[20],pixels[20];
  Pixel bg;
  Display *display;
  Drawable d;
  Screen *s;
  
  SP("CreatePixmapFromXPM");
  display=XtDisplay(top);
  s=XtScreen(top);
  d=XRootWindowOfScreen(s);
  
  sscanf(data[0],"%d %d %d %d",&width,&height,&colors,&chars);
  if (chars>1)
  {
    printf("Too many chars/pixel in xpm\n");
    EP;
    return pixmap;
  }
  if (colors>255)
  {
    printf("Too many colors in xpm\n");
    EP;
    return pixmap;
  }
  XtVaGetValues(top,XmNbackground,&bg,NULL);
  gcv.foreground=WhitePixelOfScreen(s);
  gcv.background=bg;
  gcv.line_style=LineSolid;
  gc=XCreateGC(display,d,GCLineStyle|GCForeground|GCBackground,&gcv);
  pixmap=XCreatePixmap(display,d,width,height,DefaultDepthOfScreen(s));
  cm=DefaultColormapOfScreen(s);
  mask[0]=1;
  mask[1]=0;
  pixels[0]=1;
  pixels[1]=0;
  for (x=0;x<colors;x++)  
  {
    sscanf(data[1+x],"%c c %s",&c_char,color);
    if (!strcmp(color,"None"))
      xc[(int)c_char].pixel=bg;
    else
    {
      XParseColor(display,cm,color,&xc[(int)c_char]);
      if ((XAllocColor(display,cm,&xc[(int)c_char]))==0)
        printf("Error allocating color\n");
    }
  }
  for (y=0;y<height;y++)
  {
    for (x=0;x<width;x++)
    {
      XSetForeground(display,gc,xc[(int)data[1+colors+y][x]].pixel);
      XDrawPoint(display,pixmap,gc,x,y);
    }
  }
  EP;
  return pixmap;
}
